/****************************************************************************
					FILE: 		DFalloc.h
					DESCR:		memory allocation function(user)
					AUTH:		Fei Li	
					DATE:		April 1999
****************************************************************************/

/***************************************************************************
	LIST of MCROS:	STRALLOC (char *DEST,char *SRC),
					STRCOPY  (char *DEST,char *SRC),
					MALLOC   (pointer NEW,TYPE_STR),
					CALLOC   (pointer NEW,SIZE_T N, TYPE_STR);
****************************************************************************/
/*_________________________________________________________________________*/
/*					NOTE: You may use memory manipulation function
						  Refer to memuser.h
*___________________________________________________________________________*/

#ifndef MYALLOC 
#define MYALLOC

#include <stdio.h>
#include <stdlib.h>

#define MORECHAR 1

/* allocate for a string and ending character if any 
 */
#define STRALLOC(DEST,SRC)\
        if( (DEST=(char*)malloc(strlen(SRC) + MORECHAR ) )==NULL)\
	        {\
				fprintf(stderr,"string malloc failure.\n");\
				exit(1);\
	        }

/* string copy to a string pointer
 */
#define STRCOPY(DEST,SRC)\
		STRALLOC(DEST,SRC);\
		DEST=(char*)strcpy(DEST,SRC);

/* malloc and error handling
 */
#define MALLOC(NEW,TYPE)\
		if( (NEW=(TYPE*)malloc(sizeof(TYPE)))==NULL)\
			{\
				fprintf(stderr,"malloc failure.\n");\
				exit(1);\
			}

/* calloc and error handling
 */
#define CALLOC(NEW,N,TYPE)\
		if( (NEW=(TYPE*)calloc(N,sizeof(TYPE)))==NULL)\
			{\
				fprintf(stderr,"calloc failure.\n");\
				exit(1);\
			}

#endif 
