/**************************************************************************
			FILE:		DFfile.h
			DESCR:		file operation (user)
			AUTH:		Fei Li
			DATE:		April 1999
			REVISED:	Sep. 2000
			REVISED:    Jun. 2001
***************************************************************************/

#ifndef _SELF_DEFINED_FILE_OP
#define _SELF_DEFINED_FILE_OP

#include "DFtype.h"

#define MAX_STR_BUF 500
#define SEEK_CUR 	1

/****************************
* following features are    *
* not well supported by     *
* Debian GNU/Linux 
* cc/gcc Compiler,          *
* so they are commented!!   *
****************************/
/****************************
  temporarily commented!!
#if defined(__STDC__)
#define ARGS(args) args
#else
#define ARGS(args) ()
#endif
****************************/


/*>>> user-visible functions */
/**--------------------------------------------------------------**/
/** used as replacement **/
extern 	void	printToFileEnd	(FILE*, FILE*);
extern	void	toLineHead	(FILE*);
extern	BOOLEAN	toNextLine	(FILE*);
extern	long	IDstrLineCount	(FILE*, char*);
extern	BOOLEAN	IDstrSearch	(FILE*, char*);
extern	BOOLEAN IDvalSearch	(FILE*, char*, float);
/**--------------------------------------------------------------**/
/**--------------------------------------------------------------**/
/** temporarily commented!! **/
/**
extern	void 	printToFileEnd 	ARGS((FILE*, FILE*));
extern 	void 	toLineHead		ARGS((FILE*));
extern	BOOLEAN toNextLine		ARGS((FILE*));
extern	long 	IDstrLineCount	ARGS((FILE*, char*));
extern	BOOLEAN IDstrSearch		ARGS((FILE*, char*));
extern	BOOLEAN IDvalSearch		ARGS((FILE*, char*, float));
**/
/**--------------------------------------------------------------**/

/*==================================================================
	LIST of MACROS:	
		FOPEN		(FILE* FPOINTER, char* FILENAME, char* MODE),
		ID_STR_SEARCH	(FILE* FPOINTER, char* STR_TO_SEARCH),
		ID_VAL_SEARCH	(FILE* FPOINTER, char* STRING, float VAL);
====================================================================*/
				


/* open a file, including error msg output */
#define FOPEN(FPOINTER,FILENAME,MODE)\
		if((FPOINTER=fopen(FILENAME,MODE))==NULL)\
		{\
			fprintf(stderr,"Cannot open file %s.\n",FILENAME);\
			exit(1);\
		}


/*  search an ID (string) in a file from current file position 
	and set file pointer just after the matched string.
	Error handling included.
*/
#define ID_STR_SEARCH(FPOINTER,STR_TO_SEARCH)\
		if(IDstrSearch(FPOINTER,STR_TO_SEARCH)==FALSE)\
			{\
				 fprintf(stderr,"Cannot find ID str %s.\n",STR_TO_SEARCH);\
				 exit(1);\
			}



/*  search an ID (string) that have a specified value
	from current file position and set file pointer 
	just after the very string & value.
	Error handling included.
*/
#define ID_VAL_SEARCH(FPOINTER,STRING,VAL)\
		if(IDvalSearch(FPOINTER,STRING,VAL)==FALSE)\
		{\
			fprintf(stderr,"NO MATCH!\n");\
			exit(1);\
		}


#undef ARGS

#endif
