/*****************************************************************************
			FILE:		DFstring.h
			DESCR:		string operation (user)
			AUTH:		Fei Li
			DATE:		April 1999
*****************************************************************************/


#ifndef _SELF_DEFINED_STR_OP
#define _SELF_DEFINED_STR_OP

#if defined(__STDC__)
#define ARGS(args) args
#else
#define ARGS(args) ()
#endif

#include "DFtype.h"

/*>>> user-visible functions */

/* change ASCII characters in a string to upper case
 */
extern	char*	strupper	(char*);

/* get substring from index1 to index2.
   index starts from 0.
*/
extern	char*	getSubStr	(char*, int, int);

/* find a specified character in a string and return its index 
   for the first occurrence.  <-1> is returned if fail.
 */
extern 	int		findSpecChar (char*, char);	

/* find a specified character in a string and return its index
   for the last occurrence. <-1>returned if fail
 */
extern	int		findLastSpecChar (char*, char);

/* find a specified character c in a string, and use the sub-string
   from behind c, not including c, to replace the original string
 */
extern 	BOOLEAN	strCutBehindSpecChar (char*, char);

/* left shift the specified part of a string several times,
   and fill the empty place with '0'.
 */
extern 	void	lshStr		(char*, int, int, int);

/* convert a signed integer into string.
   the integer should not exceed the range -32768 ~ 32767.
 */
extern 	char*	intToStr	(int);

/* obtain a filename string without path information */
extern  char*	strip_path_from_filename(char full_filename[]);

/*========================================================================*/
/*extern	char*	strupper	ARGS((char*));*/
/*extern	char*	getSubStr	ARGS((char*, int, int));*/
/*extern 	int		findSpecChar ARGS((char*, char));	*/
/*extern	int		findLastSpecChar ARGS((char*, char));*/
/*extern 	BOOLEAN	strCutBehindSpecChar ARGS((char*, char));*/
/*extern 	void	lshStr		ARGS((char*, int, int, int));*/
/*extern 	char*	intToStr	ARGS((int));*/
/*extern 	char*	strip_path_from_filename ARGS(char full_filename[]);*/
/*========================================================================*/


#undef ARGS

#endif
