#ifndef	 _PW_INIT_DATA_
#define  _PW_INIT_DATA_

#include "PWcir.h"
#include "PWilib.h"

/****************************************************
* 		SOME EXTERNAL VARIABLE DECLARED HERE 	    *
*    	FILE COULD BE INCLUDED ONLY ONCE       		*
****************************************************/


/****************************************************
NOTE:	WHEN CHANGE LIB NO.,PROGRAM LINES OF instLibNo 
		NEED TO BE MODIFIED accordingly, because they
		are used as indices!!!
****************************************************/

/*for gates with all inputs being equivalent,
only gate type is listed */

char *PWdeviceName[NUM_LIB_CELL]=
			{	"NOT",			/*1*/ /*instLibNo*/
			    "AND",
			    "NAND",
			    "OR",
			    "NOR",

				"XOR",			/*6*/
				"XNOR",
				/*-----------------------*/
				/* below not supported now */
				"MUX21",
				"AOI21",
				"AOI211",
				"AOI221",		/*11*/
				"AOI31",
				"AOI311",
				"OAI21",
				"OAI211",
				"OAI221",		/*16*/
				"OAI31",
				"OAI311",
				/*------------------------*/
				"PI",
				"PO",

				"DF",			/*21*/
				"DFR",
				"DFS",
				"DFRS",

				"BUFF",			/*25*/
			};

/* ctrlValue & inversion matrixes are accessed by instLibNo */
/* NOTE: instLibNo starting from 1 */
LOGIC_VALUE	ctrlValue[NUM_LIB_CELL]={
			VALUE_UNKNOWN,		/*NOT*/
			VALUE_0,			/*AND*/
			VALUE_0,			/*NAND*/
			VALUE_1,			/*OR*/
			VALUE_1,			/*NOR*/
			VALUE_UNKNOWN,		/*XOR*/
			VALUE_UNKNOWN,		/*XNOR*/
			VALUE_UNKNOWN,		/*MUX21*/
			VALUE_UNKNOWN,		/*AOI*/
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,		/*OAI*/
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,		/*PI_LIB_NO*/
			VALUE_UNKNOWN,		/*PO_LIB_NO*/

			VALUE_UNKNOWN,		/*DF*/
			VALUE_UNKNOWN,		/*DFR*/
			VALUE_UNKNOWN,		/*DFS*/
			VALUE_UNKNOWN,		/*DFRS*/

			VALUE_UNKNOWN,		/*BUFF*/
					};			

LOGIC_VALUE	inversion[NUM_LIB_CELL]={
			VALUE_1,			/*NOT*/
			VALUE_0,			/*AND*/
			VALUE_1,			/*NAND*/
			VALUE_0,			/*OR*/
			VALUE_1,			/*NOR*/

			VALUE_UNKNOWN,		/*XOR*/
			VALUE_UNKNOWN,		/*XNOR*/
			VALUE_UNKNOWN,		/*MUX*/
			VALUE_UNKNOWN,		/*AOI*/
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,		/*OAI*/
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,
			VALUE_UNKNOWN,

			VALUE_0,			/*PI*/
			VALUE_0,			/*PO*/

			VALUE_UNKNOWN,		/*DF*/
			VALUE_UNKNOWN,		/*DFR*/
			VALUE_UNKNOWN,		/*DFS*/
			VALUE_UNKNOWN,		/*DFRS*/

			VALUE_0,			/*BUFF*/
					};


/*-------------------------------------------------------------------*/
/* >>>Below is not needed currently!!!*/

/* operation table for primitive gates with at most 2-inputs */
/* 1st subscript for gate type,
   2nd for input excitation No.1
   3rd for input excitation No.2
*/
int PWoptTable[4][4][4]=
			{						/** excitation: r f s1 s0 ***/
				{					/** index:      3 2 1  0  ***/
				{1 , 1 , 1 , 1},	/** NOT OPERATION ***/
				{0 , 0 , 0 , 0},
				{3 , 3 , 3 , 3},
				{2 , 2 , 2 , 2} },

				{
				{0 , 0 , 0 , 0},	/** AND OPERATION ***/
				{0 , 1 , 2 , 3},
				{0 , 2 , 2 , 0},
				{0 , 3 , 0 , 3} },

				{
				{0 , 1 , 2 , 3},	/** OR OPERATION ***/
				{1 , 1 , 1 , 1},
				{2 , 1 , 2 , 1},
				{3 , 1 , 1 , 3} },

				{
				{0 , 1 , 2 , 3},	/** XOR OPERATION ***/
				{1 , 0 , 3 , 2},
				{2 , 3 , 0 , 1},
				{3 , 2 , 1 , 0} }
			};


/*operation table for Mux*/

/**********************  C  I1 I2 **************************
 **********************  ^  ^  ^  **************************
 **********************  |  |  |  *************************/
int PWMuxTable[4][4][4]=
			{	
  				{
  /** C==s0*/	{0 , 0 , 0 , 0},
				{1 , 1 , 1 , 1},
				{2 , 2 , 2 , 2},
				{3 , 3 , 3 , 3} },

  				{
  /*  C==s1*/   {0 , 1 , 2 , 3},
				{0 , 1 , 2 , 3},
				{0 , 1 , 2 , 3},
				{0 , 1 , 2 , 3} },

  /*********I2== s0, s1, f , r *********/ 
  				{
  /* C==fall*/  {0 , 2 , 2 , 0},
  /* I2->I1 */  {3 , 1 , 1 , 3},
				{0 , 2 , 2 , 0},
				{3 , 1 , 1 , 3} },

  				{
  /* C==rise*/  {0 , 3 , 0 , 3},
  /* I1->I2 */  {2 , 1 , 2 , 1},
				{2 , 1 , 2 , 1},
				{0 , 3 , 0 , 3} }
			};

/* >>>Above is not needed currently!!! */
/*--------------------------------------------------------------------*/


long    PWlineNum;				/* # of lines in input file */
long	PWinstNum;				/* # of logic gates/instances */
long	PWinstNum_and_pseudo;	/* # of all the instances including pseudo IO*/
long	PrimInNum,PrimOutNum;   /* # of PI/PO, including pseudo PI/PO */
long	DF_Num=0;				/* # of flip-flops */

long	PSEUDO_PI_index,PSEUDO_PO_index; /* starting index for pseudo PI/PO */
int     pseudoCount=0;					 /* # of pseudo PI&PO */
long	vdd_index=-1;					 /* index for reserved keyword vdd/gnd*/
long	gnd_index=-1;

PW_INST * instList;						 /* list of instances */
PW_INST	* unknownCellList;				 /* list of unknown instances */
PW_INST	* DFlipList;					 /* list of flip-flops */

PW_INST * SourceP[MAX_PI], * SinkP[MAX_PO]; /* sources: PI & pseudo PI */
											/* sinks:   PO & pseudo PO */
PW_INST * LevList;							/* the list for levelized ckt */


/* bucket */
PW_BUCKET	*PWbucketList;					/* list of buckets */
PW_BUCKET	*PWbucketTail;					/* tail pointer for each bucket  */
int			maxGainIndex;					/* index for the max gain ->     */
											/*->for the 1st bucket with gates*/
/* for Imax/Fanout */
long    sortedInstNum;
PW_INST ** instSortedList;

/* debugging output file*/
FILE 	*dbgFp;
/* output result file */
FILE	*resultFp;

/* MFFC */
lin_table_rec MFFClistHead,MFFClistTail;	/* list for MFFCs */
lin_table_rec MFFCrootList;		/* list for root gates in MFFC */
lin_table_rec nonMFFCrootList;	/* list for non-root gates in MFFC */
int			  gainShiftAmount;	/* the gain adjustment amount for root gates */
int			  numberofMFFC;		/* # of MFFCs */
BOOLEAN       MFFC_Id[MAX_NUM_MFFC]; 		/* MFFC ID matrix */

/* current waveform library */
ilib_table_t *PWilib_table;		/* Lookup Table for powerup current waveform */

#endif
