#ifndef _PW_routines_
#define _PW_routines_

#include "PWcir.h"
#include "logicOpt.h"

extern void		PWimax_gain_c(void);
extern void		PWimax_gain(void);
extern void		PWimax_fanout(void);
extern int 		PWimax_ilib(float turnon_time);
extern void		LFPWmaxCharge_gain_c(void);
extern void		PWmaxCharge_gain(void);
extern void		PWmaxCharge_fanout(void);

extern void 	PWimplyStackRelease(void);
extern void 	PW_MFFC_Release(void);
extern void 	PWbucketRelease(void);
extern void 	PWsource_sink_release(void);
extern void 	PWinstRelease(void);
extern void 	PWinstInSortedListRelease(void);
extern void 	PWlevListRelease(void);
extern void		PWfieldRelease(void);
extern void 	NetRelease(FILE*, FILE*, FILE*);
extern void 	NetRead(FILE*);
extern void		IntelNetRead(FILE* fin);
extern void		initPWinst(PW_INST *list);
extern void		PWlabelLevel(void);
extern void		PWchkLevAssump(void);
extern void		PWformLevList(void);
extern int		PWgetLibNo(char *cell, char *devNameList[]);
extern void     PWinstListPREInsert(PW_INST **list, PW_INST *inst);
extern void 	PWinstListPOSTInsert(PW_INST **list, PW_INST *inst);
extern PW_INST  *PWinstListPREPop(PW_INST **list);
extern void     dualLinkNOTType(char* pinName, PW_INST* inInst, long lineNo, BOOLEAN zflag);
extern void     dualLinkAllEqu(char* pinName, PW_INST* inInst, long lineNo, BOOLEAN zflag);
extern void     dualLinkDFtype(char *pinName, PW_INST *inInst, long lineNo, BOOLEAN zflag);
extern void     linkOutput(PW_INST* inInst, PW_INST *nextInst, BOOLEAN zflag);
extern void     PWlabelCirFanOut_FanIn(void);
extern PW_INST	* createPIinst(char *name);
extern PW_INST  * createPOinst(char *name);

extern LOGIC_VALUE fetchImplyValueInStk(PW_INST *pInst);
extern LOGIC_VALUE evaluateGate();
extern int		reportMaxCharge();
extern void		initImplyStk(void);

extern BOOLEAN	backwardImplication(PW_INST *pInst, LOGIC_VALUE assignment, stk_rec *stack);
extern BOOLEAN  forwardImplication(PW_INST *pInst, LOGIC_VALUE assignment, stk_rec *stack);
extern void     forwardImplyPI3V(PW_INST *targetPI, LOGIC_VALUE assignmentPI, 
								 stk_rec *trackStkTop, int *gain_MFFC_root);
extern BOOLEAN  detectImplicitJustifyFailure(PW_INST *pInst, LOGIC_VALUE expected_assign);
extern int		implyGate(PW_INST *pInst, LOGIC_VALUE assign_value, stk_rec *trackStkTop, BOOLEAN *pConflict);
extern void		PWinputSort(void);
extern void		PWinputSortOneGate(PW_INST *q);

extern void		PWinputSort_fanout(void);
extern void		PWinstSort_fanout(void);

extern int		gain2index(int gain);
extern int		index2gain(int index);
extern int		minGainRootGates(lin_table_rec MFFCrootList, BOOLEAN initFlag);
extern int		maxGainNonRootGates(lin_table_rec   nonMFFCrootList,
									BOOLEAN         initFlag);
extern void		shiftAction(lin_table_rec   MFFCrootList,
							int             increment,
							BOOLEAN         initFlag);

extern void		shiftOneGain(int *pGain, int increment);
extern int		getProperMinGain(PW_INST *pInst, BOOLEAN initFlag);
extern int		getProperMaxGain(PW_INST *pInst, BOOLEAN initFlag);
extern int		nextMaxGainIndex(int currIndex);
extern void		updtGateGain(PW_INST *pInst, BOOLEAN initFlag, stk_rec *trackStk);
extern void		updtGainWholeCircuit(stk_rec *addList,stk_rec *removeList,bi_lin_table_rec *reArrangeList);
extern void		PWgateInitGain(void);
extern void		PWgateInitGain_gain(void);

extern void		updtBucketWholeCircuit(lin_table_rec addList, lin_table_rec removeList, bi_lin_table_rec reArrangeList, PW_BUCKET *PWbucketList, PW_BUCKET *PWbucketTail);
extern void		updtInputOrderWholeCircuit();
extern void		PWbucketUpdt(lin_table_rec removeList, bi_lin_table_rec reArrangeList);
extern void		PWbucketRemoveGarbage(lin_table_rec removeList);
extern void     PWbucketReArrange(bi_lin_table_rec reArrangeList);
extern void     assignBucket(PW_INST *pInst, PW_BUCKET *PWbucketList, PW_BUCKET *PWbucketTail);
extern PW_BUCKET_ELEM* accessMaxBucketElem(PW_BUCKET *bucketlist, int maxGainIndex);
extern void		PWbucketInit(void);


extern void		PWclusterMFFC(PW_INST* instanceList, long instanceNum,
						 	  PW_INST ** POlist, long POnum,
							  lin_table_rec* pMFFClistHead,
							  lin_table_rec* pMFFClistTail,
							  lin_table_rec* pMFFCrootList,
							  lin_table_rec* pnonMFFCrootList);

extern void 	randomGenInit1();
extern void 	randomGenInit2();

extern void 	PWimplyStackGarbageClean(void);
extern void 	rand_input_vec_gen(int mode);
extern void 	simple_sim_operation(void);
extern BOOLEAN 	detectSW(PW_INST *pInst);
extern void 	state_vec_propagate(void);
extern int		reportMaxSW(void);
extern int		rand_logic_value(double);

extern void		PWrand_vec_simple_sim(int ilib_flag, float turnon_time);
extern void		PWnormSwitchingSim(void);

extern void		PWexportSp(FILE*,int);
extern double   exhaustive_spice_powerup(char *base_file_name, int typeNum);

extern void 	PWdump_ckt(FILE *dbgFp);
extern void	    dump_input_vector(FILE *fout, int vec[]);

extern int		get_imaxup_read_flag(void);
extern int 		get_imaxup_rilib_flag(void);

#endif
