#ifndef _HASH_TABLE_DATA_ROUTINES_
#define	_HASH_TABLE_DATA_ROUTINES_

#include "memuser.h"
#include "DFtype.h"
#include "DFfile.h"

/* the element in each bucket of the hash table */
struct hashTableElem
{
	char 		hashkey[MAX_STR_BUF];
	pointer		dataP;
};

typedef struct hashTableElem HASH_TABLE_ELEM;

/* routines */

/* initialize hash table */
extern void hashTableInit(lin_table_rec **table, int size);

/* insert into hashtable */
extern void hashTableInsert(lin_table_rec *table, char *key, pointer hashdata, int size, 
                            unsigned long (*hashfunc)(char *hashkey));

/* search hashtable */
extern pointer hashTableFind(lin_table_rec *table, char *key, int size, 
                             unsigned long (*hashfunc)(char *hashkey));

/* completely release memory including user-data, be careful */
extern void hashTableRelease(lin_table_rec **table, int size);
/* release only hashtable structure */
extern void hashTableRelease1(lin_table_rec **table, int size);

/* hash functions */
extern unsigned long strHF1(char *key);
extern unsigned long strHF2(char *key);

#endif
