#ifndef _LEAKAGE_CURRENT_LIBRARY_
#define _LEAKAGE_CURRENT_LIBRARY_

#include "PWilib.h"
#include "PWcir.h"

/* generic gate type table */
extern char *generic_type_index_table[];

/* leakage current library table */
extern ilib_table_t * leakage_ilib_table;



/* -----------functions--------------------------------------------*/

/* read in the leakage current libarary file */
extern int read_leakage_ilib(FILE* leakage_ilibFp, FILE* dbgFp);

/* init */
extern void alloc_init_leakage_ilib(ilib_table_t **table, int total_entry_num, int fanin_num, int fanin_field_bits, int flag);

/* dumping */
extern void dump_lkg_ilib(ilib_table_t *table, FILE *dbgFp);

/* access to leakge current library using the instance pointer */
extern double accessLkgILIB_by_instance(ilib_table_t *table, PW_INST *inst);




extern double lookup_lkg_ilib_table(ilib_table_t * table, int table_index, int pattern);

extern int encoded_input_pattern(PW_INST *inst);

extern int read_leakage_value(FILE* fin, ilib_table_t *table, int index);

extern void update_counter(int * counter, int * flag, int required_num);

#endif
