/*****************************************************************
                FILE:       linearFree.h
                DESCR:      free linear table
                AUTH:       Fei Li
                DATE:       Jun. 2001
******************************************************************/

#ifndef _linear_free_
#define _linear_free_

/* free a stack: including stack elements and MEMBER CONTENT.
   Be careful to use it.
 */
extern void stackFree(stk_rec *top);

/* free a stack: only stack elements, not MEMBER CONTENT.
 */
extern void stackFree1(stk_rec *top);

/* free a queue: including queue elements and MEMBER CONTENT.
   Be careful to use it.
 */
extern void queueFree(queue_rec *head, queue_rec *tail);
/* free a queue: only queue elements, not MEMBER CONTENT
 */
extern void queueFree1(queue_rec *head, queue_rec *tail);

/* free a linear table: including records & MEMBER CONTENT.
   Be careful to use it.
   The input parameter 'tail' can be NULL.
 */
extern void lin_table_rec_Free(lin_table_rec   *head, lin_table_rec   *tail);

/* free a linear table: only records, not MEMBER CONTENT
 */
extern void lin_table_rec_Free1(lin_table_rec   *head, lin_table_rec   *tail);

/* free a bi-linked linear table: including records & MEMBER CONTENT.
   Be careful to use it.
   The input parameter 'tail' can be NULL.
 */
extern void bi_lin_table_rec_Free(bi_lin_table_rec   *head, bi_lin_table_rec   *tail);
/* free a bi-linked linear table: only records, not MEMBER CONTENT.
 */
extern void bi_lin_table_rec_Free1(bi_lin_table_rec   *head, bi_lin_table_rec   *tail);

#endif
