/*****************************************************
			FILE:		logicOpt.h
			DESCR:		logic operation
			AUTH:		Fei Li
			DATE:		Jun 2001
******************************************************/
#ifndef _logic_operation_
#define _logic_operation_

/* multi-logic-value encoding */
/* one byte is used for one value */
#define  LOGIC_VALUE        char
#define  STATE_TYPE         0
#define  IMPLY_STK_TYPE     1

#define  VALUE_0            (LOGIC_VALUE)0
#define  VALUE_1            (LOGIC_VALUE)255
#define  VALUE_UNJUSTIFY    (LOGIC_VALUE)4
#define  VALUE_UNKNOWN      (LOGIC_VALUE)15

/* ----------------------- routines ----------------------- */ 

/* not */
extern LOGIC_VALUE not_operation(LOGIC_VALUE var);
/* exclusive or */
extern LOGIC_VALUE xor_operation(LOGIC_VALUE varA, LOGIC_VALUE varB);
/* exclusive nor */
extern LOGIC_VALUE xnor_operation(LOGIC_VALUE varA, LOGIC_VALUE varB);

/* conversion from integer to LOGIC_VALUE */
extern LOGIC_VALUE int2logic(int i);
/* conversion from LOGIC_VALUE to integer */
extern int logic2int(LOGIC_VALUE l);

#endif
