/************************************************************************
			FILE:		DFfile.c
			DESCR:		file and string operation
			AUTH:		Fei Li
			DATE:		April 1999
			REVISED: 	Jun. 2001
*************************************************************************/

#include <stdio.h>
#include "DFalloc.h"
#include "DFfile.h"
#include "DFtype.h"

/*************************************************
*Note: conditional compilation for diff cimpiler
*	has been disabled because it's NOT well
*	supported by Debian GNU/Linux Compiler
*************************************************/
/*--------------------------------------------------------------------*/

/* print all the content after the file pointer <fin>
   into file <fout>.
*/
void
/***
#if defined(__STDC__)
***/
printToFileEnd(FILE *fin,FILE *fout)
/***
#else
printToFileEnd(fin,fout)
	FILE *fin;
	FILE *fout;
#endif
***/
{
	char c;
	while((c=fgetc(fin))!=EOF)
	{
		fputc(c,fout);
	}
}

/*-------------------------------------------------------------------*/

/* move file pointer to the head of the current sentence.
*/
void
/***
#if defined(__STDC__)
***/
toLineHead(FILE *fin)
/***
#else
toLineHead(fin)
	FILE *fin;
#endif
***/
{
	char c;
	fseek(fin,-1L,SEEK_CUR);
	if((c=fgetc(fin))!='\n')
	{
		do{
			fseek(fin,-2L,SEEK_CUR);
		  }while((c=fgetc(fin))!='\n');
	}
}

/*-------------------------------------------------------------------*/

/*	find an ID string <dest> in file.    
    The length of the string <dest> is limited by the MAX_STR_BUF.
**/


BOOLEAN
/***
#if defined(__STDC__)
***/
IDstrSearch(FILE* fpoint,char* dest)
/***
#else
IDstrSearch(fpoint,dest)
	FILE * fpoint;
	char dest[];
#endif
***/
{
 char buf[MAX_STR_BUF];
 if( (strlen(dest)+MORECHAR)>MAX_STR_BUF )
	{
		fprintf(stderr,"Too long string to be searched! \n");
		return (FALSE);
	}

 while( fscanf(fpoint,"%s",buf)!=EOF && strcmp(buf,dest)!=0);
 
 if(feof(fpoint)!=0 && strcmp(buf,dest)!=0)
  	return FALSE;
 else
	return TRUE;
}

/*--------------------------------------------------------------------*/

/*	get the number of lines containing specified ID string in a file

	NOTE>>>: if the ID string is NULL,then it gives # of lines for the file
*/
long
/***
#if defined(__STDC__)
***/
IDstrLineCount(FILE* fp, char* s)
/***
#else
IDstrLineCount(fp,s)
	FILE *fp;
	char *s;
#endif
***/
{
	long i=0;
	rewind(fp);
	if(s==NULL)
	{	while(toNextLine(fp))
			i++; /**!!!NOTE:in unix editor,though the last line we didn't**/
				/**type \n,but fgetc() still got a \n**************/
	}else {
			while(IDstrSearch(fp,s)==TRUE)
			{
				i++;
				toNextLine(fp);
			}
		  }
	return i;
}	

/*--------------------------------------------------------------------*/
/*	Move file pointer to the next line,
	No matter next line is empty or not.
*/
/* !!NOTE: next line may be empty line,
so we may need toNextNoEmptyLine() */

BOOLEAN
/***
#if defined(__STDC__)
***/
toNextLine(FILE* fp)
/***
#else
toNextLine(fp)
	FILE * fp;
#endif
***/
{
	int	i=0;
	char c;
	while((c=fgetc(fp))!='\n' && feof(fp)==0)/* no \n found & no EOF*/
	{i++;}

	if(feof(fp)!=0)	/* EOF */
		return FALSE;
	else
		return TRUE;
}

/*-------------------------------------------------------------------*/
/*	Search a ID string having a specified value in specified file. 
			Format  <string>   <val>
			Example: cell=		5
*/

BOOLEAN
/***
#if defined(__STDC__)
***/
IDvalSearch(FILE* fp, char* s, float val)
/***
#else
IDvalSearch(fp,s,val)
	FILE *fp;
	char *s;
	float val;
#endif
***/
{
	float f;
	while(IDstrSearch(fp,s)==0)
	{
		fscanf(fp,"%f",&f);
		if(f==val)
		return TRUE;
	}
	return FALSE;
}
