/***************************************************************************
			FILE:		DFstring.c
			DESCR:		string operation funcs (user)
			AUTH:		Fei Li
			DATE:		April 1999
			REVISED: 	Jun. 2001
***************************************************************************/

#include <stdio.h>
#include "DFalloc.h"
#include "DFtype.h"
#include "DFstring.h"

/*--------------------------------------------------------------------*/

/* change str to upper case */
char*
/***
#if defined(__STDC__)
***/
strupper(char* str)
/***
#else
strupper(str)
	char *str;
#endif
***/
{	int i=0;
	while(str[i]!='\0')
	{	if(str[i]>='a' && str[i]<='z')
			str[i]=str[i]-32;
		i++;
	}
	return str;
}

/*--------------------------------------------------------------------*/

/* get the specified substring */
/* <start>/<end> is index,beginning from 0 */
/* From <start> to <end> is the actual chars,
   and the function will insert \0 automatically.
*/
char*
/***
#if defined(__STDC__)
***/
getSubStr(char* str, int start, int end)
/***
#else
getSubStr(str,start,end)
	char *str;
	int	start,end;
#endif
***/
{	int n,i;
	char *tmp;
	n=end-start+1+MORECHAR;
	CALLOC(tmp,n,char);
	for(i=0;i<n-1;i++)
		tmp[i]=str[start+i];
	tmp[n-1]='\0';
	return tmp;
}

/*--------------------------------------------------------------------*/

/*	find the position of the specified char in the string ,
	the position counts from 0.

    If there are many of them, it returns the first of them.
	If there is none, it returns <-1>.
*/
int
/***
#if defined(__STDC__)
***/
findSpecChar(char* str, char c)
/***
#else
findSpecChar(str,c)
	char *str;
	char c;
#endif
***/
{	int i=0;
	int l;
	if(c=='\0')
	{	l=strlen(str);
		return l;
	}else{
			while(str[i]!='\0')
			{	if(str[i]==c)
					return i;
				else i++;
			}
			return -1;
		}
}

/*--------------------------------------------------------------------*/

/*	return position of the last matched char in a string.
	If no match, it returns <-1>.
*/
int
/***
#if defined(__STDC__)
***/
findLastSpecChar(char* str, char c)
/***
#else
findLastSpecChar(str,c)
	char    *str;
	char    c;
#endif
***/
{  
    int l;
 
    l=strlen(str);
    if(c=='\0')
    {
        return l;
    }else{  while(l>=0)
            {   if(str[l]==c)
                    return l;
                else
                        l--;
            }
            return  -1;
         }
}

/*--------------------------------------------------------------------*/

/*	cut string from behind the first matched char,
	and use the cutted part to update the original string
*/
/** NOTE: if the specified char not found, string is left unmodified **/
BOOLEAN
/***
#if defined(__STDC__)
***/
strCutBehindSpecChar(char* str, char c)
/***
#else
strCutBehindSpecChar(str,c)
	char *str;
	char c;
#endif
***/
{	int l,i;
	char *tmp;
	l=strlen(str);
	if((i=findSpecChar(str,c))<0)
		return FALSE;	
	else{	tmp=getSubStr(str,i+1,l-1);
			strcpy(str,tmp);
			return TRUE;
		}
}

/*--------------------------------------------------------------------*/

/*  left-shift the specified part of a string <count> times,
    fill the empty place with '0'
*/
void
/***
#if defined(__STDC__)
***/
lshStr(char* str, int fstIndex, int endIndex, int count)
/***
#else
lshStr(str,fstIndex,endIndex,count)
	char    str[];
	int     fstIndex,endIndex,count;
#endif
***/
{   int i,j;
    for(i=0;i<count;i++)
    {   for(j=fstIndex;j<endIndex;j++)
            str[j]=str[j+1];
        str[endIndex]='0';
    }
}

/*--------------------------------------------------------------------*/
			
/*	change a signed integer into string type */
/*  the integer shouldn't exceed the range from -32768 ~ 32767 */
char*
/***
#if defined(__STDC__)
***/
intToStr(int num)
/***
#else
intToStr(num)
	int	num;
#endif
***/
{	int	divide,i,j;
	char str[6+MORECHAR];	/*** for 2 bytes,at most -32768 ~ 32767 ***/
	char *strP;

	if(num<0)
		str[0]='-';
	else
		str[0]='+';
	num=abs(num);
	for(divide=10000,i=1;divide>=1;divide=divide/10,i++)
	{	str[i]=(num/divide)+48;
		num=num%divide;
	}
	str[5+MORECHAR]='\0';
	if(str[0]=='-')
	{	j=0;
		while(str[1]=='0' && j<4)
		{	
			lshStr(str,1,5+MORECHAR,1);
			j++;
		}
	}
	else{
			lshStr(str,0,5+MORECHAR,1);
			j=0;
			while(str[0]=='0' && j<4)
			{	
				lshStr(str,0,5+MORECHAR,1);
				j++;
			}
		}
	CALLOC(strP,strlen(str)+MORECHAR,char);
	strcpy(strP,str);
	return strP;
}

/*----------------------------------------------------------------*/
/* strip_path_from_filename(char [])
 * 
 * obtain the filename string without path information.
 * NOTE: new string memory will be allocated.
 */
char *
strip_path_from_filename(char full_filename[])
{
	int pos;
	char *partial_filename;

	if(full_filename == NULL) return NULL;

	CALLOC(partial_filename, strlen(full_filename)+MORECHAR, char);
	strcpy(partial_filename, full_filename);

	pos = findLastSpecChar(partial_filename, '/');
	while(pos!=-1)
	{
		strCutBehindSpecChar(partial_filename, '/');
		pos = findLastSpecChar(partial_filename, '/');
	}
	return partial_filename;
}
