#include "PWcir.h"
#include "linear.h"
#include "linearFree.h"
#include "linearExt.h"
#include "PWroutines.h"
#include "PWglobal_var.h"

void
NetRelease(FILE* fin,FILE* fresult,FILE* fdbg)
{
	/* release the implication stack */
	PWimplyStackRelease();

	PWinstInSortedListRelease();

	PWlevListRelease();

	PW_MFFC_Release();

	PWbucketRelease();

	PWinstRelease();

	DF_Num = 0;
	PrimInNum = PrimOutNum= 0;
	vdd_index=gnd_index=-1;
	/*pi_index=po_index=instance_index=0;*/
	pseudoCount = 0;

	PWinstNum=PWlineNum = 0;
	PWinstNum_and_pseudo = 0;
	LevList=NULL;
	PSEUDO_PI_index = PSEUDO_PO_index = 0;
	instList = NULL;
	unknownCellList = NULL;
	DFlipList = NULL;

	PWsource_sink_release();
	if(fin!=NULL) fclose(fin);
	if(fdbg!=NULL) fclose(fdbg);
	if(fresult!=NULL) fclose(fresult);

	fprintf(stdout,"Netlist released.\n");
}

void
PWfieldRelease(void)
{
	PWimplyStackRelease();
	
	PWinstInSortedListRelease();

	PW_MFFC_Release();

	PWbucketRelease();

}

void
PWimplyStackRelease(void)
{
	int	k;

	for(k=0;k<PWinstNum_and_pseudo; k++)
	{
		if(instList[k].implyStkTop != NULL)
			stackFree(&(instList[k].implyStkTop));
	}
	if( vdd_index>=0 && SourceP[vdd_index] !=NULL &&
		SourceP[vdd_index]->implyStkTop != NULL)
		stackFree(&(SourceP[vdd_index]->implyStkTop));
	if( gnd_index>=0 && SourceP[gnd_index] !=NULL &&
		SourceP[gnd_index]->implyStkTop != NULL)
		stackFree(&(SourceP[gnd_index]->implyStkTop));
}

void
PWlevListRelease(void)
{
	PW_INST	*p,*q;

	p=LevList;
	while(p!=NULL)
	{
		q = p;
		p = p->next;
		mem_free_block((pointer)q);
	}
	LevList = NULL;
}

void
PWinstInSortedListRelease(void)
{
	int	k;

	for(k=0;k<PWinstNum_and_pseudo; k++)
	{
		if(instList[k].InSortedList[0] != NULL)
			bi_lin_table_rec_Free(&(instList[k].InSortedList[0]),NULL);
		if(instList[k].InSortedList[1] != NULL)
			bi_lin_table_rec_Free(&(instList[k].InSortedList[1]),NULL);
	}
}

void
PWinstRelease(void)
{
	mem_free_block((pointer)instList);
	if(vdd_index>=0)
		mem_free_block((pointer)SourceP[vdd_index]);
	if(gnd_index>=0)
		mem_free_block((pointer)SourceP[gnd_index]);
}

void
PWsource_sink_release(void)
{
	int	i;

	for(i=0;i<MAX_PI;i++) SourceP[i]=NULL;
	for(i=0;i<MAX_PO;i++) SinkP[i]=NULL;
}

void
PWbucketRelease(void)
{
	int	i,k;

	maxGainIndex=-1;
	k=gain2index(MAX_ABS_GAIN);

	if(PWbucketList !=NULL && PWbucketTail != NULL)
	{
		for(i=0;i<=k;i++)
		{
			if(PWbucketList[i].bucketElemList != NULL && PWbucketTail[i].bucketElemList != NULL)
				bi_lin_table_rec_Free(&(PWbucketList[i].bucketElemList), &(PWbucketTail[i].bucketElemList));
		}

		mem_free_block(PWbucketList);
		mem_free_block(PWbucketTail);
	}
	PWbucketList = PWbucketTail = NULL;
}

void
PW_MFFC_Release(void)
{
	lin_table_rec p, q;

	lin_table_rec_Free1(&MFFCrootList, NULL);
	lin_table_rec_Free1(&nonMFFCrootList, NULL);

	p=MFFClistHead;
	while(p!=NULL)
	{
		q = ((lin_table_rec) (p->member));
		lin_table_rec_Free1(&q, NULL);
		p=next_lin_table_rec(p);
	}
	lin_table_rec_Free1(&MFFClistHead, NULL);

	MFFClistHead = MFFClistTail = NULL;
	gainShiftAmount = 0;
	numberofMFFC = 0;
}
