#ifndef SIS
#define SIS
#endif

#include "sis.h"
#include "PWmemcpy_sis.h"
#include "PWcir.h"

/* copy the ckt connection */
int
CktConnectCopy(network_t *network)
{
	lsGen 	gen1,gen2;
	node_t	*node,*p;
	latch_t *latch;
	PW_INST	*inst;
	int		i;

	foreach_node(network, gen1, node)
	{
		inst = (PW_INST*)(node->imaxup);
		foreach_fanin(node, i, p)
		{
			if(i>=inst->fanin)
			{
				fprintf(stderr,"wrong fanout for inst %s.\n",inst->name);
				return 1;
			}
			inst->in[i] = (PW_INST *)(p->imaxup);
		}

		i=0;
		foreach_fanout(node, gen2,p)
		{
			if(i>=inst->fanout)
			{
				fprintf(stderr,"wrong fanout for inst %s.\n",inst->name);
				return 1;
			}
			inst->out[i] = (PW_INST *)(p->imaxup);
			i++;
		}
	}

	foreach_latch(network, gen1, latch)
	{
		inst = (PW_INST*)(latch->imaxup);
		inst->out[0]=(PW_INST *)(latch->latch_output->imaxup);
		/* fix pseudo-PI's input connect */
		((PW_INST *)(latch->latch_output->imaxup))->in[0] = inst;
		inst->in[0]=(PW_INST *)(latch->latch_input->fanin[0]->imaxup);
	}
	return 0;
}

