#include "PWcir.h"
#include "PWglobal_var.h"

extern void PWdump_ckt(FILE *dbgFp);

void
PWdump_ckt(FILE *dbgFp)
{
		int i,j;

        fprintf(dbgFp,"Dump Circuit for Debugging...\n\n");
		fprintf(dbgFp,"Instances:%d\n",PWinstNum_and_pseudo);
		fprintf(dbgFp,"       DF:%d\n",DF_Num);
		fprintf(dbgFp,"  real PI:%d\n", PSEUDO_PI_index);
		fprintf(dbgFp,"      PPI:%d\n", pseudoCount);
		fprintf(dbgFp,"  PO(PPO):%d\n", PrimOutNum);


        for(i=0;i<PWinstNum_and_pseudo;i++)
        {
            fprintf(dbgFp,"\n");

            fprintf(dbgFp,"instID:%d \ninstname:%s \ninstLibNo:%d \nfanout: %d \nfanin: %d\nlevel=%d\n",
                    i,instList[i].name,instList[i].instLibNo,
                    instList[i].fanout, instList[i].fanin, instList[i].maxLev);

            fprintf(dbgFp,"its output to:\n");
            for(j=0;j<MAX_FAN_OUT&&instList[i].out[j]!=NULL;j++)
            {   fprintf(dbgFp,"out%d:%s\n",j+1,instList[i].out[j]->name);
            }
            for(j=0;j<MAX_FAN_OUT&&instList[i].outz[j]!=NULL;j++)
            {   fprintf(dbgFp,"outz%d:%s\n",j+1,instList[i].outz[j]->name);
            }
            fprintf(dbgFp,"its input from:\n");
            for(j=0;j<MAX_IN_PER_GATE&&instList[i].in[j]!=NULL;j++)
            {   fprintf(dbgFp,"in%d:%s\n",j+1,instList[i].in[j]->name);
            }

            fprintf(dbgFp,"\n");
        }

        fprintf(dbgFp,"PIs are %ld:(NOTE:PSEUDO_PI counted)\n",PrimInNum);
        for(i=0;i<MAX_PI && SourceP[i]!=NULL;i++)
        {   fprintf(dbgFp,"%d:name %s , libNo %d, \
                            ,fanout %d\n",
                        i,SourceP[i]->name, SourceP[i]->instLibNo,
                        SourceP[i]->fanout);

            fprintf(dbgFp,"\tits output to:\n");
            for(j=0;j<MAX_FAN_OUT&&SourceP[i]->out[j]!=NULL;j++)
            {   fprintf(dbgFp,"out%d:%s\n",j+1,SourceP[i]->out[j]->name);
            }
            fprintf(dbgFp,"\tits input from:\n");
            for(j=0;j<MAX_IN_PER_GATE && SourceP[i]->in[j]!=NULL;j++)
            {   fprintf(dbgFp,"in%d:%s\n",j+1,SourceP[i]->in[j]->name);
            }
            fprintf(dbgFp,"\n\n");
        }


        fprintf(dbgFp,"POs are %ld:(NOTE:PSEUDO_PO  counted)\n",PrimOutNum);
        for(i=0;i<MAX_PO && SinkP[i]!=NULL;i++)
            fprintf(dbgFp,"%d:name %s , libNo %d,maxLev %d,minLev %d\n",
                    i,SinkP[i]->name, SinkP[i]->instLibNo,
                    SinkP[i]->maxLev,SinkP[i]->minLev);


        fflush(dbgFp);
}
