#include <stdio.h>
#include "Rtime.h"
#include "PWcir.h"
#include "PWglobal_var.h"
#include "PWroutines.h"
#include "PWilib.h"
#include "PWilib_routines.h"

extern float reportMaxCurrent2(float turnon_time, BOOLEAN write_file_flag);

/* Imax/Fanout */
void
PWimax_fanout()
{
	fprintf(stdout,"Running Imax/Fanout.\n");
	fprintf(resultFp,"Running Imax/Fanout.\n");

	SetTime(TIME_REPORT);

	PWfieldRelease();
	initImplyStk();

	fprintf(stdout, "Initialization for Estimation ... \n");

	/* sorting gates according to the gates' fanout number */
	PWinstSort_fanout();
	fflush(dbgFp);
	/* sorting the gates' input pins */
	initImplyStk();
	PWinputSort_fanout();
	fflush(dbgFp);

	fprintf(stdout,"Initialization finished.\n");
	ReportTime(TIME_REPORT);


	/* ATPG based Charge Maximization for power-up current: Imax/Fanout */
	fprintf(stdout,"Estimation starting...\n");
	PWmaxCharge_fanout();

	/* report the max stored charge, which is the metric for power-up current */
	reportMaxCharge(TRUE);

    fprintf(resultFp,"report the current value using library-based model for imaxup-fanout.\n");
    reportMaxCurrent2(100, TRUE);


	fflush(dbgFp);
    	fflush(resultFp);
	fprintf(stdout,"Estimation finished. Check output file for result.\n\n\n");

}
