#include <stdio.h>
#include "Rtime.h"
#include "PWcir.h"
#include "PWglobal_var.h"
#include "PWroutines.h"


/* Imax/Gain */
void
PWimax_gain()
{
	fprintf(stdout,"Running Imax/Gain.\n");
	fprintf(resultFp,"Running Imax/Gain.\n");

	SetTime(TIME_REPORT);

	PWfieldRelease();
	initImplyStk();

	/*  initial gain assignment to gates */
	fprintf(stdout,"Initialization for Estimation...\n");
	PWgateInitGain_gain();

	/* establish the bucket using the initial gain assignment */
	/* bucket is for dynamic re-ordering of gates */
	PWbucketInit();
	fflush(dbgFp);

	/* ordering the gates' input pins */
	PWinputSort();
	fflush(dbgFp);
	fprintf(stdout,"Initialization finished.\n");
	ReportTime(TIME_REPORT);

	/* ATPG-based stored Charge Maximization for power-up current: Imax/gain-cluster */
    fprintf(stdout,"Estimation starting...\n");
    PWmaxCharge_gain();

	/* report the max stored charge, which is the metric for power-up current */
    reportMaxCharge(TRUE);

    fflush(dbgFp);
    fflush(resultFp);
    fprintf(stdout,"Estimation finished. Check output file for result.\n\n\n");
}
