#include <stdio.h>
#include "PWcir.h"

#include "PWroutines.h"
#include "PWglobal_var.h"

extern void 	initInstSortedList(void);
extern void    	instQuickSort(PW_INST **list, long low, long up);


void
PWinstSort_fanout()
{
	int	i,j;

	instSortedList=(PW_INST **) mem_get_block((SIZE_T) PWinstNum_and_pseudo * sizeof(PW_INST *));

	initInstSortedList();

	j=0;
	for(i=0;i<PWinstNum_and_pseudo;i++)
	{   /*** NOTE: PI and primitive gates are put into instSortedList
	    ****/
		if(instList[i].instLibNo!=PO_LIB_NO &&
		   instList[i].instLibNo!=DF_LIB_NO &&
		   instList[i].instLibNo!=DFR_LIB_NO &&
		   instList[i].instLibNo!=DFS_LIB_NO &&
		   instList[i].instLibNo!=DFRS_LIB_NO)
		   {
			instSortedList[j]=&(instList[i]);
			j++;
		   }
	}
	sortedInstNum=j;

	instQuickSort(instSortedList,0,sortedInstNum-1);

        /* debugging */
        /*
        fprintf(dbgFp,"The sorted instance below...\n");
        for(i=0;i<sortedInstNum;i++)
        {   fprintf(dbgFp,
        			"name=%s    SortedList No=%d   weight=%d  maxLev=%d\n",
                    instSortedList[i]->name,
                    i,
                    instSortedList[i]->fanout,
                    instSortedList[i]->maxLev);
        }

        fclose(dbgFp);
        FOPEN(dbgFp,"dbgInfo","a");
        */
}

void
initInstSortedList()
{
	int	i;
	for(i=0;i<PWinstNum;i++)
	{
		instSortedList[i]=NULL;
	}
}

/*** TO FORM NONINCREASING LIST ORDER ***/
void    instQuickSort(list,low,up)
PW_INST **list;
long    low,up;
{   long    i,j;
    double  selWeight;
    PW_INST *selInst;

    if(low<up)
    {   i=low;
        j=up;
        selWeight=list[low]->fanout;
        selInst=list[low];
        while(i!=j)
        {   while(i<j && list[j]->fanout<selWeight)
                j--;
            if(i<j) list[i++]=list[j];
            while(i<j && list[i]->fanout>selWeight)
                i++;
            if(i<j) list[j--]=list[i];
        }
        list[i]=selInst;
        instQuickSort(list,low,i-1);
        instQuickSort(list,i+1,up);
    }

}

