#include "PWcir.h"
#include "linearFree.h"
#include "linearExt.h"

#include "PWroutines.h"
#include "logicOpt.h"
#include "PWglobal_var.h"


extern void 		JustifyAssignment_fanout(PW_INST *pInst, LOGIC_VALUE assignment);
extern void			Backtrace_fanout(PW_INST *pInst, LOGIC_VALUE assignment, 
									 PW_INST **targetPI, LOGIC_VALUE *assignmentPI);
extern void 		accessPIbacktrackStkTop();
extern void         nextDecision();
extern void			updtInputOrderByFanoutForAllGates_fanout();
/*
extern void 		gateListForUpdtGain();
extern void 		updtGateListGain();
extern void 		PWgateListInputSort();
extern int			logic2int();
extern void 		manipulateBucketUpdtList();
extern bi_lin_table_rec get_bi_lin_table_rec_tail();
*/


void
PWmaxCharge_fanout()
{
	int				i;

	for(i=0;i<sortedInstNum;i++)
	{	

		/* justification of assignment */
		/* success = */
		JustifyAssignment_fanout(instSortedList[i],VALUE_1);

	}
}

void
JustifyAssignment_fanout(pInst,assignment)
PW_INST		*pInst;
LOGIC_VALUE	assignment;
{
	LOGIC_VALUE		assignmentPI;
	PW_INST			*targetPI;
	BOOLEAN			conflict;
	BOOLEAN			uniqueValueDetected;
	BOOLEAN			backtrackFg,passFg;
	PW_IMPLY_STRU	*PIbacktrackElem=NULL;
	stk_rec			PIbacktrackStk=NULL;
	stk_rec			tmpRec;
	double			triedTimes;				
	int         	tmpval;

	stk_rec				assigned_gate_list;
	bi_lin_table_rec	reArrange_gate_list;

	uniqueValueDetected=FALSE;
	PIbacktrackElem=NULL;
	PIbacktrackStk=NULL;

	/* assignemnt has already done because of pervious justification */
	if(fetchImplyValueInStk(pInst)!=VALUE_UNKNOWN)
		return;

	while(fetchImplyValueInStk(pInst)!=assignment && uniqueValueDetected==FALSE)
	{
		/***
		if(fetchImplyValueInStk(pInst)!=VALUE_UNKNOWN)
		{
			fprintf(stderr,"Incorrect logic conflict in Justification of %s with assignment %d \n",
							pInst->name,logic2int(assignment));
			exit(1);
		}
		***/

		/* get one taget PI */
		Backtrace_fanout(pInst,assignment,&targetPI,&assignmentPI);

		/* currently selected PI hasn't trigger backtracking */
		backtrackFg=FALSE;
		passFg=FALSE;

		/* push target into backtracking stack */
		PIbacktrackElem=(PW_IMPLY_STRU *)mem_get_block((SIZE_T) sizeof(PW_IMPLY_STRU));
		PIbacktrackElem->inst=targetPI;
		PIbacktrackElem->value=assignmentPI;

		STK_PUSH(&PIbacktrackStk,(double)0,(pointer)PIbacktrackElem);

	  assigned_gate_list=NULL;
	  reArrange_gate_list=NULL;

	  /* backtracking may be expected here */
	  while(PIbacktrackStk!=NULL && passFg==FALSE)
	  {

		/* access backtrack stack top */
		/* get the PI for 3-value forward implication */
		/* it could be for : first time or tracktracked target */
		accessPIbacktrackStkTop(PIbacktrackStk,&targetPI,&assignmentPI,&triedTimes);


		/* assignment of PI and IMPLICATION */
		/* we don't have conflict if using PODEM, 
		   But we still need backtracking 
		*/
		forwardImplyPI3V(targetPI,assignmentPI,&assigned_gate_list, &tmpval);


		/*
		if(conflict==TRUE)
		{
			fprintf(stderr,"Conflict for PI implication. Impossible!.\n");
			fprintf(stderr,"Check the Error!.\n");
			exit(1);
		}
		*/

		if(assignmentPI==VALUE_UNKNOWN)
		{
			/* remove PI in this time from backtrack stack */
			tmpRec=STK_POP(&PIbacktrackStk);
			mem_free_block((pointer)(tmpRec->member));
			mem_free_block((pointer)(tmpRec));

			if(PIbacktrackStk!=NULL)
			{	/* still have chance to justify */
				accessPIbacktrackStkTop(PIbacktrackStk,&targetPI,&assignmentPI,&triedTimes);

				/* remove PI in previous time from backtrack stack */
				tmpRec=STK_POP(&PIbacktrackStk);
				mem_free_block((pointer)(tmpRec->member));
				mem_free_block((pointer)(tmpRec));

				nextDecision(&targetPI,&assignmentPI,&triedTimes);
				PIbacktrackElem=(PW_IMPLY_STRU *)mem_get_block((SIZE_T) sizeof(PW_IMPLY_STRU));
				PIbacktrackElem->inst=targetPI;
				PIbacktrackElem->value=assignmentPI;
				STK_PUSH(&PIbacktrackStk,(double)triedTimes,(pointer)PIbacktrackElem);
			}
			/* else, the justification failed */

		}else

		{

			/* present PIs' assignment combination failed to justif assignment */
			/* backtracking needed */
			if( (fetchImplyValueInStk(pInst)!=VALUE_UNKNOWN && fetchImplyValueInStk(pInst)!=assignment)
				|| (fetchImplyValueInStk(pInst)==VALUE_UNKNOWN && detectImplicitJustifyFailure(pInst,assignment)==TRUE))
			{
				backtrackFg=TRUE;

				/* get one more wrong decision */
				accessPIbacktrackStkTop(PIbacktrackStk,&targetPI,&assignmentPI,&triedTimes);
	
				/* remove wrong decision from backtrack stack */
				tmpRec=STK_POP(&PIbacktrackStk);
				mem_free_block((pointer)(tmpRec->member));
				mem_free_block((pointer)(tmpRec));

				/* get next decision according to the previous wrong one */
				/* push into backtrack stack for net trying */
				nextDecision(&targetPI,&assignmentPI,&triedTimes);
				PIbacktrackElem=(PW_IMPLY_STRU *)mem_get_block((SIZE_T) sizeof(PW_IMPLY_STRU));
				PIbacktrackElem->inst=targetPI;
				PIbacktrackElem->value=assignmentPI;
				STK_PUSH(&PIbacktrackStk,(double)triedTimes,(pointer)PIbacktrackElem);
			}else
			{
				/* the initially selected PI is passed */
				/* or the backtracking is successful */
				/* but justification not completed */
				passFg=TRUE;
			}

			/*restoreImplication(&assigned_gate_list);*/
			/* bit reversion */
			/*implyGate(targetPI,not_operation(assignmentPI),&assigned_gate_list,&conflict);
			if(conflict==TRUE)
			{
				fprintf(stderr,"Conflict for PI implication. Impossible!.\n");
				fprintf(stderr,"Check the Error!.\n");
				exit(1);
			}*/
			/* because we use incremental gain updating, 
			   some uniquely dertermined gates after previous assignment justification 
			   may not be detected until here!
			*/
			/*if(fetchImplyValueInStk(pInst)!=VALUE_UNKNOWN && fetchImplyValueInStk(pInst)!=assignment)
			{
				restoreImplication(&assigned_gate_list);*/
				/* the unique value this gate output may have */
				/*implyGate(pInst,not_operation(assignment),&assigned_gate_list,&conflict);
				uniqueValueDetected=TRUE;

				if(conflict==TRUE)
				{
					fprintf(stderr,"Impossible value for %s, ID %d\n in JustifAssignment()",pInst->name,pInst->instID);
					exit(1);
				}
			}
			*/
		}
	  }

		if(PIbacktrackStk==NULL)
		{
			/* the justification cannot be performed successfully
			   under current situation
			*/
			/* so the gate output has already been implicitely determined */
			/* but we don't detect until here because of incremental gain updating */
			implyGate(pInst,not_operation(assignment),&assigned_gate_list,&conflict);
			uniqueValueDetected=TRUE;
			if(conflict==TRUE)
			{
				fprintf(stderr,"Impossible value for %s, ID %d\n in JustifAssignment()",pInst->name,pInst->instID);
				exit(1);
			}

			/****
			addList=removeList=NULL;
			reArrangeList=NULL;
			updtGainWholeCircuit(&addList,&removeList,&reArrangeList);
			updtBucketWholeCircuit(addList,removeList,reArrangeList,PWbucketList,PWbucketTail);
			updtInputOrderWholeCircuit(addList,reArrangeList);
			****/
			updtInputOrderByFanoutForAllGates_fanout(instList,PWinstNum);


			/*
			stackFree1(&addList);
			stackFree1(&removeList);
			bi_lin_table_rec_Free1(&reArrangeList,NULL);
			bi_lin_table_rec_Free1(&reArrange_gate_list,NULL);
			stackFree1(&assigned_gate_list);
			*/

		}else
		{
			/* the selected PI should be passed here */
			if(passFg==FALSE)
			{
				fprintf(stderr,"Impossible situation in Justification.\n");
				fprintf(stderr,"Check backtracking process.\n");
				exit(1);
			}

			if(backtrackFg==FALSE)
			{
				/* get the gate list for updating */
				/*gateListForUpdtGain(assigned_gate_list,&reArrange_gate_list);*/

				/* update the gain of each gate in the list */
				/*updtGateListGain(&reArrange_gate_list,&assigned_gate_list);*/
				/*PWbucketUpdt(assigned_gate_list,reArrange_gate_list);*/

				/* re-sort the input */
				/*PWgateListInputSort(reArrange_gate_list);*/

				updtInputOrderByFanoutForAllGates_fanout(instList,PWinstNum);

				/***
				bi_lin_table_rec_Free1(&reArrange_gate_list,NULL);
				stackFree1(&assigned_gate_list);
				***/
			}else
			{
				/***
				addList=removeList=NULL;
				reArrangeList=NULL;
				updtGainWholeCircuit(&addList,&removeList,&reArrangeList);
				updtBucketWholeCircuit(addList,removeList,reArrangeList,PWbucketList,PWbucketTail);
				updtInputOrderWholeCircuit(addList,reArrangeList);
				***/

				updtInputOrderByFanoutForAllGates_fanout(instList,PWinstNum);

				/***
				stackFree1(&addList);
				stackFree1(&removeList);
				bi_lin_table_rec_Free1(&reArrangeList,NULL);
				bi_lin_table_rec_Free1(&reArrange_gate_list,NULL);
				stackFree1(&assigned_gate_list);
				***/
			}
		}

		/*reportBucketContent();*/
		fflush(dbgFp);
	}

	/* justification succeed */
	stackFree(&PIbacktrackStk);
}

/* after backtracing, we get target PI and its expected assignment */
void
Backtrace_fanout(pInst,assignment,targetPI,assignmentPI)
PW_INST     *pInst;
LOGIC_VALUE assignment;
PW_INST     **targetPI;
LOGIC_VALUE *assignmentPI;
{
    LOGIC_VALUE inv,inVal1,inVal2;
    int         pinID;
    int         index[2];

    (*targetPI)=pInst;
    (*assignmentPI)=assignment;

    while((*targetPI)->instLibNo!=PI_LIB_NO)
    {
      /* for gates with controlling value and inversion parity*/
      if( (*targetPI)->instLibNo==NOT_LIB_NO ||
          (*targetPI)->instLibNo==AND_LIB_NO ||
		  (*targetPI)->instLibNo==NAND_LIB_NO ||
		  (*targetPI)->instLibNo==OR_LIB_NO ||
		  (*targetPI)->instLibNo==NOR_LIB_NO ||
          (*targetPI)->instLibNo==BUFF_LIB_NO )
      {
        inv=inversion[(*targetPI)->instLibNo-1];
        /* input value */
        (*assignmentPI)=xor_operation(inv,(*assignmentPI));

        if((*targetPI)->InSortedList[logic2int(*assignmentPI)]==NULL)
        {
            fprintf(stderr,"No x-path for backtracing of %s with \
                            assignment %d\n",
                            pInst->name, logic2int(assignment));
            exit(1);
        }

        pinID=(int) (((*targetPI)->InSortedList[logic2int(*assignmentPI)])->key);
        (*targetPI)=(*targetPI)->in[pinID];
      }

      else      /* gates with no controlling value */
            if((*targetPI)->instLibNo==XOR_LIB_NO ||
              (*targetPI)->instLibNo==XNOR_LIB_NO)
           {

                /* both inputs are determined already */
                if( (*targetPI)->InSortedList[0]==NULL ||
                    (*targetPI)->InSortedList[1]==NULL)
                {
                    fprintf(stderr,"No x-path for backtracing of %s with \
                                    assignment %d\n",
                                    pInst->name, logic2int(assignment));
                    exit(1);
                }

                /* we have x-path for XOR or XNOR gate */
                index[0]=(int) (*targetPI)->InSortedList[0]->key;
                index[1]=(int) (*targetPI)->InSortedList[1]->key;

                inVal1=fetchImplyValueInStk((*targetPI)->in[0]);
                inVal2=fetchImplyValueInStk((*targetPI)->in[1]);

                if(inVal1==VALUE_UNKNOWN && inVal2==VALUE_UNKNOWN)
                {
                    /* we always prefer value_1, because it's fanout-based */
                    pinID=(int) (((*targetPI)->InSortedList[1])->key);
                    (*targetPI)=(*targetPI)->in[pinID];
                    (*assignmentPI)=VALUE_1;

                    /***
                    if((*targetPI)->in[index[0]]->gain_st[0] >
                        (*targetPI)->in[index[1]]->gain_st[1])
                    {
                        (*targetPI)=(*targetPI)->in[index[0]];
                        (*assignmentPI)=VALUE_0;
                    }else{
                            (*targetPI)=(*targetPI)->in[index[1]];
                            (*assignmentPI)=VALUE_1;
                         }
                    ***/
                }else{
                        /* only one uncertain input, 
                           so another can be determined now
                        */
                        if( (*targetPI)->instLibNo==XOR_LIB_NO )
                            (*assignmentPI)=
                            xor_operation( ((inVal1==VALUE_UNKNOWN)?inVal2:inVal1),
                                           (*assignmentPI) );
                        else
                            (*assignmentPI)=
                            xnor_operation( ((inVal1==VALUE_UNKNOWN)?inVal2:inVal1),
                                            (*assignmentPI) );

                        pinID=(*targetPI)->InSortedList[logic2int(*assignmentPI)]->key;
                        (*targetPI)=(*targetPI)->in[pinID];
                     }

           }else{
                    fprintf(stderr,"Unknown instance in Backtrace_fanout() for %s!!\n",
                                pInst->name);
                    exit(1);
                }


    }
}
