#include <stdio.h>
#include "PWcir.h"
#include "DFrandom.h"
#include "DFtype.h"
#include "Rtime.h"

#include "PWroutines.h"
#include "PWilib_routines.h"
#include "PWglobal_var.h"

/*
extern PW_INST  * SourceP[MAX_PI], * SinkP[MAX_PO];
extern long	PrimInNum, PrimOutNum;
extern PW_INST	* LevList;
extern long		PSEUDO_PI_index;
*/

extern int rand_logic_value(double  probability1);
extern float max_current_in_waveform(float turnon_time);
extern int accessCurrentILIB(ilib_table_t *table, PW_INST *inst, float time, float turnon_time);

extern void input_vec_copy(PW_INST *SourceP[], int vec[]);



void
PWrand_vec_simple_sim(int ilib_flag, float turnon_time)
{
   int time_counter = 0;
   int i;
   int rand_max=0, currCharge;
   float current, maxCurrent=0;
   int vec[MAX_PI];

   fprintf(stdout,"Running Logic Simulation for Power-up Current (1 vector)\n");
   fprintf(resultFp,"\n\nRunning Logic Simulation for Power-up Current (1 vector)\n");

   SetTime(TIME_REPORT);
   initImplyStk();
   randomGenInit1();

   /**
   for(i=0;i<2;i++)
   {
   		rand_input_vec_gen();
   		simple_sim_operation();
   		currCharge=reportMaxCharge(FALSE);
   		rand_max = DF_MAX(rand_max,currCharge);


   }

   curr_sw = reportMaxSW();
   rand_max_sw = DF_MAX(rand_max_sw, curr_sw);
   **/

   for(i=0;i<5000;i++)
   {
	if(time_counter >= 5 )
    {
      	PWimplyStackGarbageClean();
        time_counter = 0;
    }
    else time_counter++;

	rand_input_vec_gen(RAND_INPUT_VEC_ALL_PI);

	simple_sim_operation();
	currCharge=reportMaxCharge(FALSE);
	rand_max = DF_MAX(rand_max,currCharge);

    if(ilib_flag != 0)
    {
		current= max_current_in_waveform(turnon_time);
		maxCurrent = DF_MAX(maxCurrent, current);
        if(maxCurrent == current)
		{
		    /* keep the good vector */
		    input_vec_copy(SourceP, vec);
		}
		if(i< 100 )
		{
			fprintf(resultFp, "The max current so far is %f.\n", maxCurrent);
		}else if(i%500 == 0)
		      {
		      	fprintf(resultFp,"The max current so far at 500 interval is %f.\n", maxCurrent);
			  }
	}

	/**
	curr_sw = reportMaxSW();
	rand_max_sw = DF_MAX(rand_max_sw, curr_sw);
	**/
   }
   fprintf(stdout,"the max charge for random vectors is %d.\n",rand_max);
   fprintf(resultFp,"the max charge for random vectors is %d.\n",rand_max);
   if(ilib_flag != 0)
   {
   fprintf(resultFp,"the max current based on the ilib is %f.\n",maxCurrent);
   fprintf(stdout,"the max current based on the ilib is %f.\n",maxCurrent);
   }
   dump_input_vector(resultFp,vec);

   fflush(resultFp);
   ReportTime(TIME_REPORT);
}

/*it generates a random vector and push it into PI/pseudo_PI's implying stack*/
void
rand_input_vec_gen(mode)
int	mode;
{
 	int		i;
	int		value;
	LOGIC_VALUE	lvalue,*pValue;


	if(mode == RAND_INPUT_VEC_ALL_PI)
	{
		for(i=0;i<PrimInNum;i++)
		{
			if(strcmp(SourceP[i]->name,"GND")==0 ||
			   strcmp(SourceP[i]->name,"VDD")==0 ||
			   strcmp(SourceP[i]->name,"VSS")==0 ||
			   strcmp(SourceP[i]->name,"VCC")==0)
			{
				continue;
			}

			value = rand_logic_value(0.5);
			lvalue= int2logic(value);
			pValue=(LOGIC_VALUE *)mem_get_block((SIZE_T) sizeof(LOGIC_VALUE));
			(*pValue)=lvalue;
			STK_PUSH(&(SourceP[i]->implyStkTop),(double)NOT_CARE_KEY,
					 (pointer)pValue);
		}
	}else if(mode == RAND_INPUT_VEC_REAL_PI)
		  {
		  	/* for real PIs, ignoring pseudo_PIs */
		  	for(i=0;i<PSEUDO_PI_index;i++)
		  	{
		  		if(strcmp(SourceP[i]->name,"GND")==0 ||
		  		   strcmp(SourceP[i]->name,"VDD")==0 ||
		  		   strcmp(SourceP[i]->name,"VSS")==0 ||
		  		   strcmp(SourceP[i]->name,"VCC")==0)
				{
					continue;
				}

		  		value = rand_logic_value(0.5);
		  		lvalue= int2logic(value);
		  		pValue=(LOGIC_VALUE *)mem_get_block((SIZE_T) sizeof(LOGIC_VALUE));
		  		(*pValue)=lvalue;
		  		STK_PUSH(&(SourceP[i]->implyStkTop),(double)NOT_CARE_KEY,
		  				 (pointer)pValue);
			}
		  }else {
		  			fprintf(stderr,"Unknown mode for rand_input_vec_gen().\n");
		  			exit(1);
			    }
}

/* generate 1 or 0 according to the probability of 1 */
int
rand_logic_value(probability1)
double	probability1;
{
	double	v;

	v=drand48();
	if(v>=0.0 && v<=probability1)
		return 1;
	else	return 0;
}

void
simple_sim_operation()
{
	PW_INST		*p, *q;
	LOGIC_VALUE	currValue,*pValue;
	int			i;

	p=LevList;
	while(p!=NULL)
	{
		q=p->out[0];
		while(q!=NULL)	/* gate in this level */
		{
			currValue=evaluateGate(q,IMPLY_STK_TYPE);
			pValue=(LOGIC_VALUE *)mem_get_block((SIZE_T) sizeof(LOGIC_VALUE));
			(*pValue)=currValue;
			STK_PUSH(&(q->implyStkTop),(double)NOT_CARE_KEY,(pointer)pValue);
			
			q=q->next;
		}
		p=p->next;
	}

	for(i=0;i<PrimOutNum;i++)
	{
		currValue = evaluateGate(SinkP[i],IMPLY_STK_TYPE);
		pValue=(LOGIC_VALUE *)mem_get_block((SIZE_T) sizeof(LOGIC_VALUE));
		(*pValue)=currValue;
		STK_PUSH(&(SinkP[i]->implyStkTop),(double)NOT_CARE_KEY,(pointer)pValue);
	}
}

float
max_current_in_waveform(float turnon_time)
{
	int			i;
	float 		t_start, t_end, t_step, time;
    float       maxCurrent=0, current_at_time=0;
    float       maxCurrentWithoutPI=0;
    float       maxCurrentRealPI=0;
    int         charge_pseudo_PO=0;
    int         charge_second_latch=0;
    LOGIC_VALUE lv;
    int         v;

	time_range_step(PWilib_table, turnon_time, instList, &t_start, &t_end, &t_step);

  for(time = t_start; time <=  t_end; time += t_step)
  {
  	maxCurrentWithoutPI = 0;
	for(i=0;i<PWinstNum_and_pseudo;i++)
	{
		/* DF is also in the ilib */
		if(instList[i].instLibNo!=PO_LIB_NO)
		{
			if(accessCurrentILIB(PWilib_table, &(instList[i]), time, turnon_time)==1)
			{
				fprintf(stderr,"Error while accessCurrentILIB().\n");
				exit(1);
			}

			if(instList[i].instLibNo!=DF_LIB_NO &&
			   instList[i].instLibNo!=DFS_LIB_NO &&
			   instList[i].instLibNo!=DFR_LIB_NO &&
			   instList[i].instLibNo!=DFRS_LIB_NO)
			{
				lv = fetchImplyValueInStk(&(instList[i]));
			}else{
					lv = fetchImplyValueInStk(instList[i].out[0]);
				 }
			v =logic2int(lv);

			if(instList[i].instLibNo!=PI_LIB_NO)
				maxCurrentWithoutPI+=instList[i].powerup_current->current[v];
		}
	}

	maxCurrentRealPI=0;
	/* for real primary inputs: which are buffers */
	for(i=0;i<PSEUDO_PI_index;i++)
	{
		lv=fetchImplyValueInStk(SourceP[i]);
		v=logic2int(lv);
		maxCurrentRealPI+= SourceP[i]->powerup_current->current[v];
	}
	current_at_time = maxCurrentWithoutPI + maxCurrentRealPI;
	maxCurrent = DF_MAX(maxCurrent, current_at_time);
  }
  return maxCurrent;
}

void
dump_input_vector(FILE *fout, int vec[])
{
	int i;
	fprintf(fout,"the corresponding vector -- \n");
	for(i=0;i<PrimInNum;i++)
	{
		fprintf(resultFp,"PI_name=%s, value=%d\n",
				SourceP[i]->name,
				vec[i]);
	}
}

void
input_vec_copy(PW_INST *SourceP[], int vec[])
{
	int i;
	for(i=0;i<PrimInNum;i++)
	{
		vec[i]=logic2int(fetchImplyValueInStk(SourceP[i]));
	}
}
