/*************************************************************************
		FILE:		Rtime.c
	 	DESCR:		Run Time Report
	     	AUTH: 		Li, Fei
	     	DATE: 		April 1999
	     	VER:		1.0
**************************************************************************/

/*
**	Those routines report the time info used by
**	exchange processes.
*/

#include <stdio.h>
#include <sys/types.h>
#include <sys/times.h>

#include "Rtime.h"

static clock_t Tms_utime;
static clock_t Tms_stime;

/* Record the time point before a pass */
void
SetTime(report_flag)
int	report_flag;
{
	struct	tms buffer;

	if(report_flag==1)
	{
		if (times(&buffer) != -1)
		Tms_utime = buffer.tms_utime; 
		Tms_stime = buffer.tms_stime; 
	}
}

/* Report the time used according Settime op */
void
ReportTime(report_flag)
int	report_flag;
{
	struct	tms buffer;
	float	utime, stime;
	char	str[32];

	if(report_flag==1)
	{
		if (times(&buffer) != -1)
		utime = (float)(buffer.tms_utime-Tms_utime)/60; 
		stime = (float)(buffer.tms_stime-Tms_stime)/60; 
		sprintf(str, "Time -> User: %f, Sys: %f\n", utime, stime);
		printf("%s\n",str);
	}
}

/* End of Rtime.c */
