/***************************************************************************
				FILE:  	linearExt.c
				DESCR:	linear table operation (extra part)
				AUTH:	Fei Li
				DATE:	Jun. 2001
****************************************************************************/
#include	"linearExt.h"

/* forward traversal, get the next record */
lin_table_rec
next_lin_table_rec(lin_table_rec current)
{
    if(current==NULL)
        return NULL;
    else
        return current->next;
}

/* forward traversal, get the next record */
bi_lin_table_rec
next_bi_lin_table_rec(bi_lin_table_rec current)
{
    if(current==NULL)
        return NULL;
    else
        return current->next;
}

/* lookup by <member pointer> */
/* matched record is returned */
bi_lin_table_rec
bi_lin_table_lookup_by_member(bi_lin_table_rec head, pointer pMember)
{
	bi_lin_table_rec	p;

	p=head;
	while(p!=NULL)
	{
		if((p->member)==pMember)
			return p;
		p=next_bi_lin_table_rec(p);
	}

	return NULL;
}

/* lookup by <member pointer> */
/* matched record is returned */
/* record right before the matched record is obtained through parameter*/
lin_table_rec
lin_table_rec_lookup_by_member(lin_table_rec head, pointer pMember, lin_table_rec *preRec)
{
	lin_table_rec	p;

	p=head;
	while(p!=NULL)
	{
		if((p->next->member)==pMember)
		{
			(*preRec)=p;
			return p->next;
		}
		p=next_lin_table_rec(p);
	}

	return NULL;
}

/* transfer all elements in stack head2 to stack head1 */
void
stackTransfer(stk_rec *head1, stk_rec *head2)
{
	stk_rec rec;
	pointer	pMember;
	double  key;

	rec=STK_POP(head2);
	while(rec!=NULL)
	{
		pMember=rec->member;
		key=rec->key;
		mem_free_block((pointer)rec);

		STK_PUSH(head1,(double)key,(pointer)pMember);

		rec=STK_POP(head2);
	}
}
