/*****************************************************************
				FILE:		linearFree.c
				DESCR:		rotuines to free linear table
				AUTH:		Fei Li
				DATE:		Jun. 2001
******************************************************************/
#include	"linear.h"
#include 	"linearFree.h"

/* destroy  stack : including stack element & MEMBER CONTENT */
void
stackFree(top)
stk_rec	*top;
{
	stk_rec	tmpRec;

	while((*top)!=NULL)
	{
		tmpRec=STK_POP(top);
		mem_free_block((pointer)(tmpRec->member));
		mem_free_block((pointer)tmpRec);
	}
}

/* destroy queue: including queue element & MEMBER CONTENT */
void
queueFree(head,tail)
queue_rec	*head;
queue_rec	*tail;
{
	queue_rec	tmpRec;

	while((*head)!=NULL || (*tail)!=NULL)
	{
		tmpRec=QUEUE_POP(head,tail);
		mem_free_block((pointer)(tmpRec->member));
		mem_free_block((pointer)tmpRec);
	}
}

/* destroy stack: only stack element, not MEMBER CONTENT */
void
stackFree1(top)
stk_rec *top;
{
	stk_rec tmpRec;

    while((*top)!=NULL)
    {
		tmpRec=STK_POP(top);
	    mem_free_block((pointer)tmpRec);
	}
}

/* destroy queue: only queue element , not MEMBER CONTENT */
void
queueFree1(head,tail)
queue_rec   *head;
queue_rec   *tail;
{
    queue_rec   tmpRec;

    while((*head)!=NULL || (*tail)!=NULL)
    {
	    tmpRec=QUEUE_POP(head,tail);
        mem_free_block((pointer)tmpRec);
    }
}

/* input parameter 'tail' can be NULL */
void
lin_table_rec_Free(head,tail)
lin_table_rec	*head,*tail;
{
	lin_table_rec	tmpRec;

	while((*head)!=NULL)
	{
		tmpRec=lin_table_prev_del(head,tail);
		mem_free_block((pointer)(tmpRec->member));
		mem_free_block((pointer)tmpRec);
	}
}

/* destroy linear table, : only record element, not MEMBER CONTENT */
void
lin_table_rec_Free1(head,tail)
lin_table_rec   *head,*tail;
{
		lin_table_rec   tmpRec;

	    while((*head)!=NULL)
        {
            tmpRec=lin_table_prev_del(head,tail);
            mem_free_block((pointer)tmpRec);
        }
}

/* 'tail' can be NULL */
void
bi_lin_table_rec_Free(head,tail)
bi_lin_table_rec	*head,*tail;
{
	bi_lin_table_rec	tmpRec;

	while((*head)!=NULL)
	{
		tmpRec=bi_lin_table_prev_del(head,tail);
		mem_free_block((pointer)(tmpRec->member));
		mem_free_block((pointer)tmpRec);
	}
}

/* destroy bi-linked linear table, : only table record, not MEMBER CONTENT */
void
bi_lin_table_rec_Free1(head,tail)
bi_lin_table_rec   *head,*tail;
{
	bi_lin_table_rec   tmpRec;

    while((*head)!=NULL)
    {
        tmpRec=bi_lin_table_prev_del(head,tail);
        mem_free_block((pointer)tmpRec);
    }
}

