/*
 * mape_curgrp.c
 *
 * the maximum current estimation for a group of 
 * gates. 
 * 
 * Changbo Long. Jan. 18, 2002. 
 *
 * When set all the input to be transistion, the 
 * difference between the current for each input
 * vector is not so large. So, I guess that perhaps
 * we can get the maximum current simply by a 
 * simple formula. It will proportional to the 
 * number of stages in the circuit and proportional 
 * to the number of the primary input and reversely
 * proportional to the number of the stages in the 
 * critical path. Just a reminder to validate this 
 * sometime in the near future. (Jan. 18. 2002). 
 */
#include "mape_int.h"


void
mape_curgrp(network)
network_t *network ;
{
	lsList groups ;
	lsList group ;
	lsHandle h ;
	node_t *node ;
	lsGen gen, gen1 ;
	int i = 0 ;
	double time  ;

	/* get a group of gates */
	groups = mape_group_get_groups(network) ;

	/* dump the spice file for spice simulation*/
	mape_spigrp(network, groups) ;

	/* dump the group's estimation value when input is FALL and RISE*/
	lsForeachItem(groups, gen, group){
		mape_clean_given_gate() ;
		lsForeachItem(group, gen1, node)
			mape_push_given_gatep(node) ;
		mape_current(network) ;
		mape_cur_clear(network) ;
	}

	/* dump the maximum estimation and vectors. */
	lsForeachItem(groups, gen, group){
		mape_clean_given_gate() ;
		lsForeachItem(group, gen1, node)
			mape_push_given_gatep(node) ;
		mape_curitr(network, &time, NULL) ;
		mape_curitr_dump_input(network) ;
		mape_spice_dump_curitr_input(network) ;
		mape_curitr_clear(network) ;
	}
}
