#ifndef MAPE_INT_H
#define MAPE_INT_H
/*
 * map_int.h
 *
 * use as the internal definition 
 * to the mape package. 
 */
#include <sis.h>
#define MAPEOUTPUT "sismape.out"
#define MAXFAMILYCUBES 56

#define MAPE_CUBE_EMPTY 	0
#define MAPE_CUBE_CHANGED 	1
#define MAPE_CUBE_UNCHANGED 	2

#define NO_CTRL_VALUE		0
#define NORMAL_CTRL_VALUE	1
#define REVERSE_CTRL_VALUE	2

#define LSLENGTH(l) (l==NULL?0:lsLength(l))
#define TRANSITION_VALUE(v) (v == MAPE_RISE || v == MAPE_FALL)

#define USING_PODEM 	0
#define USING_RDM 	1
#define USING_ITR	2
#define USING_UPB	3
#define USING_GROUP	4
#define USING_CURRENT 	5
#define USING_SPICE	6
#define USING_CURITR	7
#define USING_CURGRP 	8
#define USING_SPIGRP 	9
#define USING_OPTGRP 	10
#define USING_SAGRP	11
#define USING_SAPLT	12
#define USING_SASSC	13
#define USING_MSPPLT	14
#define USING_CURSA	15
#define USING_TATPG	16
#define USING_PIPELINE	17
#define USING_CLOCKSKEW 18
#define USING_CURGA	19
#define USING_CURRDM	20
#define USING_TATPGGRP	21
#define USING_CURGAGRP	22
#define USING_CURLOC	23
#define USING_PBSSCE	24
#define USING_RDMAVG	25
#define USING_CURPLOC	26
#define USING_PBSSCEGRP 27
#define USING_DUMP 	28
#define USING_CURRDMGRP	29
#define USING_SOSA	30
#define USING_DEPSA	31
#define USING_DISKSIM	32
#define USING_STN	33

#define USING_PODEM_S 	"podem"
#define USING_RDM_S 	"random"
#define USING_ITR_S	"iteration"
#define USING_UPB_S	"upb"
#define USING_GROUP_S	"group"
#define USING_CURRENT_S	"current"
#define USING_SPICE_S	"spice"
#define USING_CURITR_S	"curitr"
#define USING_CURGRP_S 	"curgrp"
#define USING_SPIGRP_S 	"spigrp"
#define USING_OPTGRP_S 	"optgrp"
#define USING_SAGRP_S 	"sagrp"
#define USING_SAPLT_S 	"saplt"
#define USING_SASSC_S	"sassc"
#define USING_MSPPLT_S	"mspplt"
#define USING_CURSA_S	"cursa"
#define USING_TATPG_S	"tatpg"
#define USING_PIPELINE_S "pipeline"
#define USING_CLOCKSKEW_S "clockskew"
#define USING_CURGA_S 	"curga"
#define USING_CURRDM_S 	"currdm"
#define USING_TATPGGRP_S "tatpggrp"
#define USING_CURGAGRP_S "curgagrp"
#define USING_CURLOC_S 	 "curloc"
#define USING_PBSSCE_S	 "pbssce"
#define USING_RDMAVG_S	 "rdmavg"
#define USING_CURPLOC_S	 "curploc"
#define USING_PBSSCEGRP_S "pbsscegrp"
#define USING_DUMP_S 	 "dump"
#define USING_CURRDMGRP_S "currdmgrp"
#define USING_SOSA_S	  "sosa"
#define USING_DEPSA_S	  "depsa"
#define USING_DISKSIM_S	  "disksim"
#define USING_STN_S	  "stn"

#define MAX_VOLTAGE 1.3
#define UNKNOWN_VOL  -9999.9
#define SLOP_TIME 50.0
#define HALF_SLOP_TIME 25.0
#define CLOCK_CYCLE 2000

#define RISE_DIRECTION 1
#define FALL_DIRECTION 0
#define UNKNOWN_DIRECTION 2

#define ZERO_DELAY_MODEL 	1
#define UNIT_DELAY_MODEL 	2
#define REAL_DELAY_MODEL 	3
#define ZERO_DELAY_MODEL_S 	"zero"
#define UNIT_DELAY_MODEL_S 	"unit" 
#define REAL_DELAY_MODEL_S 	"real" 

#define SSCOBJ_GROUP_SUM 	1
#define SSCOBJ_GROUP_MAX	2
#define SSCOBJ_MSP_MAX		3
#define SSCOBJ_GROUP_SUM_S	"group_sum" 	
#define SSCOBJ_GROUP_MAX_S	"group_max"	
#define SSCOBJ_MSP_MAX_S	"msp_max"	

#define CGATE_AREA		1      
#define	LATCH_AREA		4

//#define FIX_GROUP_SIZE		4
#define FIX_GROUP_SIZE		9
#define FIX_GROUP_GATE		16

#define FIX_GROUP	1
#define MSP_GROUP	2

#define CURLIB_APPROX_DELAY_UNIT  5.0

#define DEFAULT_LIB_GATE "not"

#define NODE_SIM_CURR(node)     (((mape_t *)(node->mape))->sim.curr)
#define NODE_SIM_HC(node)       (((mape_t *)(node->mape))->sim.hc)
#define NODE_SIM_HP(node)       (((mape_t *)(node->mape))->sim.hp)

//#define GROUP_SAMPLE_RATE 15	 // for size of 4 
#define GROUP_SAMPLE_RATE 4	 // for size of 16
//#define GROUP_SAMPLE_RATE 5	 // for size of 9

typedef enum mape_curlib_param_type_enum mape_curlib_param_type_t ;

enum mape_curlib_param_type_enum{
	MAPE_CURLIB_RDLAY ,
	MAPE_CURLIB_FDLAY ,
	MAPE_CURLIB_IRMAX ,
	MAPE_CURLIB_IFMAX ,
	MAPE_CURLIB_IRPOS ,
	MAPE_CURLIB_IFPOS ,
	MAPE_CURLIB_IRDIS ,
	MAPE_CURLIB_IFDIS , 
	MAPE_CURLIB_CIRCUIT, 
	MAPE_CURLIB_EFFIN , 
	MAPE_CURLIB_LOAD ,
	MAPE_CURLIB_LOADG
};

typedef enum mape_node_value_enum mape_node_value_t ; 
enum mape_node_value_enum {
	MAPE_FALL,	/*10*/
	MAPE_RISE,      /*01*/
	MAPE_U_0,  	/*X0*/
	MAPE_0_U,	/*0U*/ 
	MAPE_0_0,	/*00*/ 
	MAPE_U_U,	/*XX*/ 
	MAPE_1_1,	/*11*/ 
	MAPE_1_U,	/*1U*/ 
	MAPE_U_1	/*U1*/
};

typedef struct mape_cur_node_value_struct{
	/*lsList trans_values ;*/ /* all the transition values in one node. */
	lsList vol_points ;		/* voltage points to describe the voltage waveform*/
	node_t *pi ;			/* which pi cause the change */
	mape_node_value_t pi_value ; 	/*the pi's value in the change */
	lsList trans_values ;
	double delay ;			/*approximate delay of the node*/
}mape_cur_node_value_t ;

typedef struct mape_delay_value_struct{
	mape_node_value_t value ; /*value without delay information*/
	double delay ;	/*if it is a transistion, calculate the delay time*/
	int times ;	/*how many times this transition is evoked*/
	int propogate ; /* if this transistion will be propogated ? */
	node_t *pi ;	/*from which pi this value is implicated */
	mape_node_value_t pi_value ; /*the pi's value*/
}mape_delay_value_t ;

typedef struct imp_value_struct {
	mape_node_value_t value ;
	node_t *pi ; 		/*from which pi this value is implicated*/
	mape_node_value_t pi_value ; /*the pi's value*/
}mape_imp_value_t;

typedef struct mape_curlib_param_struct{
	double *x ;
	double *y ;
	double *y2a ;
} mape_curlib_param_t ;

typedef struct mape_curlib_loadg_struct{
	char   **gate ;
	double *rdlay ;
	double *fdlay ;
	double *irmax ; 
	double *ifmax ; 
	double *irpos ;
	double *ifpos ;
	double *irdis ;
	double *ifdis ;
}mape_curlib_loadg_t ;

typedef struct mape_gate_curlib_struct{
	char *name ;
	int n ;
	double  effin ;              /*effect input capacitance*/
	mape_curlib_loadg_t *loadg ; /*special loading gate case */
	mape_curlib_param_t *rdlay ; /*input input rise delay*/
	mape_curlib_param_t *fdlay ; /*input input fall delay*/
	mape_curlib_param_t *irmax ; /*max current when input rise*/
	mape_curlib_param_t *ifmax ; /*max current when input fall*/
	mape_curlib_param_t *irpos ; /*max current position for the input rise*/
	mape_curlib_param_t *ifpos ; /*max current position for the input fall*/
	mape_curlib_param_t *irdis ; /*duration of the max current when input rise*/
	mape_curlib_param_t *ifdis ; /*duration of the max current when input fall*/
}mape_curlib_gate_t;

typedef struct mape_node_placement_struct{
	int row ;
	int col ;
	int area ; /* area of the node, which should be 1 for normal or 4 for register*/
	int wire ; /* the wire length of the gate */
	double prob ;	/*probability*/
	lsList st_list ; /*switching time and possibility list*/
	int st_value ; /*the switching_time possibility value*/
	int group ;	/* the group value for the node */
	int st_id ;	/* st_id for this node */
}mape_node_plt_t ;

typedef struct mape_clockskew_struct{
	double l_delay ;
	double s_delay ;
}mape_clockskew_t ; 

typedef struct mape_struct{
	int level ;			/*the level of the node*/
	lsList values; 			/*used as a stack for podem operations*/
	lsList cur_values ;		/*used for the current estimation package*/
	lsList pi_fanin;		/*all the PIs that affect the node's value*/
	int visit ;			/*indict is this node be visited*/
	mape_node_value_t rdm_v; 	/*used for random input's implication */
	mape_node_value_t rdm_max ; 	/*used to record all the maximum 
					  instance using random method */
	mape_node_plt_t *plt ;		/*placement information for the node*/
	mape_curlib_gate_t *curlib_gate;/*corresponding gate in the curlib*/
	int C0; 			/*controllability for 0 */
	int C1;				/*controllability for 1 */
	lsList reps;			/*the PIs which is responsible for the untransistion*/
	mape_clockskew_t *cs ;		/*for clockskew package*/
	char *depsa ;			/*for depsa package */

	struct{				/* structure for simulation */
		lsGen curr ;	
		lsHandle hc, hp ;
	}sim ;

	struct{				/* special for pbssce */
		double tmpr ;		/* tmperate value */	
		lsList cl ;		/* current list */		
		lsGen gen ;		/* a gen for visiting cl */
		lsList zol ;		/* the zo list for estiming maximum current */
		char *curzo ;		/* current zo */
		lsList sw_static ;	/* static information for switch */		
		lsList cantl ;		/* current values at the candidate time */ 
	}pbssce ;
}mape_t;

/* define the user's option structure */
typedef struct mape_option_struct{
	int 	method ; 			/*using podem method or rdm method. */
	struct {
		int 	perc ;			/*for random mode, */		
		int 	times ;
	}rdm_option;
	struct {
		int 	fanout_priority  ;	/*the fanout priority*/			 		
		int 	level_priority	 ;	/*the node's level priority*/
		int	backtrack_limit  ;	/*the backtrack limitation */
		int	backtrace_limit  ;	/*the backtrace pi's limitation, pi's percent*/
		int 	backtrace_limit_a ; 	/*the actuall pi's number */
	}podem_option;
	struct{
		int 	generation ;		/*the number of the generation in ga*/
		int 	pi_bit	;		/*the bit number to specify the switching time in each pi*/
		int 	bit_unit ;		/*the distance between two adjacent switching time in pi*/
	}curga_option ;
	int 	verb ;				/*print in the verbos mode*/
	FILE *	output ;			/*output file*/
	lsList  given_gates ;			/*user defined given gates*/
	int 	delay_model ;			/*delay model*/
	int 	ssc_obj ;			/*SSC objective function type */
	int	mug ;				/*Max unchangeable group */
	int 	version ;			/*the mathod version */
	float	max_cp ;			/*max critical path time allowed*/ 
}mape_option_t ;

typedef struct mape_nv_pair_struct{
	node_t *node ;
	mape_node_value_t value ;
}mape_nv_pair_t;

/* a pont in the current waveform */
typedef struct mape_cur_point_struct {
	double time ;
	double value ;
}mape_cur_point_t ;

/* a point in the voltage waveform */
typedef struct mape_vol_point_struct {
	double time ;
	double value ;
	int multi ;
}mape_vol_point_t ;

/* st */
typedef struct mape_mspplt_st_struct{
	int     step ;  /*switching time, represented by logic depth*/
	float   rp ;    /*rising possibility*/
	float   fp ;    /*falling possibility*/
	float   hp ;    /*stay high possibility*/
	float   lp ;    /*stay low possibility*/
} mape_mspplt_st_t ;

/* st under real circuit model*/
typedef struct mape_pbssce_st_struct{
	double   time ;  /*switching time, represented by logic depth*/
	float   rp ;    /*rising possibility*/
	float   fp ;    /*falling possibility*/
	float   hp ;    /*stay high possibility*/
	float   lp ;    /*stay low possibility*/
} mape_pbssce_st_t ;

#define mape_value_determined(v) (v == MAPE_RISE || v == MAPE_FALL || \
				  v == MAPE_0_0 ||  v == MAPE_1_1) 
extern FILE *mapeout ;
/*for debug only */
extern network_t *global_network ;
extern mape_option_t *user_option;

/* dumping the information of the network*/
extern void dump_network(network_t *);
extern void dump_node(node_t *) ;
extern void dump_set(int, pset) ;
extern void dump_s_set(char *, int, pset) ;

/* some utilities*/
extern mape_t *mape_create_mape_t(void) ;
extern void mape_free_mape_t(mape_t *) ;
extern int mape_node_is_latch(node_t *) ;
extern void mape_clear_node_list(lsList) ;

/* stack operations*/
extern void mape_push(node_t *, mape_node_value_t, node_t *, mape_node_value_t) ; 
extern int mape_pop(node_t *, node_t *, mape_node_value_t) ; 
extern int mape_conflict(mape_node_value_t, mape_node_value_t) ; 
extern mape_node_value_t mape_value_not(mape_node_value_t) ;
extern mape_node_value_t mape_value_first_not(mape_node_value_t) ;
extern mape_node_value_t mape_value_second_not(mape_node_value_t) ;
extern int mape_set_value_not(int) ;
extern mape_node_value_t mape_3_to_9(int) ;
extern mape_node_value_t mape_top(node_t *) ;
extern mape_node_value_t mape_top_pi_value(node_t *) ;
extern node_t* mape_top_pi(node_t *) ;
extern int mape_top_first(node_t *) ;
extern int mape_top_second(node_t *) ;
extern mape_node_value_t mape_value_convert(int , int) ;
extern void mape_push_rdm(node_t *, mape_node_value_t) ; 
extern void mape_push_rdm_max(node_t *, mape_node_value_t) ; 
extern mape_node_value_t mape_rdm_value(node_t *node) ;
extern int mape_rdm_value_first(node_t *) ;
extern int mape_rdm_value_second(node_t *) ;
extern mape_node_value_t mape_simulate_node(node_t *) ;

/*get the level of every node in the network*/
extern int mape_get_node_level(node_t *) ;
extern int mape_fanout_cmp(char **, char **) ;
extern int mape_level_cmp(lsGeneric, lsGeneric) ;

/*The mape function of the master function of the whole package*/ 
extern int mape(network_t *) ;

/*get a cover's control value*/
extern int mape_node_ctrl_value(pset_family, int *, int *) ;
extern char *mape_print_node_value(mape_node_value_t) ;
extern char *mape_node_value_string(mape_node_value_t, char *) ;
extern char *mape_node_value_string_c(mape_node_value_t, char *) ;

/* */
extern void mape_error(char *, char *, int) ;
extern void mape_debug(char *) ;
extern void mape_report(network_t *, int, long) ;
extern void mape_rdm_report(network_t *, int, long) ;

/* for timing and space analysis */
extern void mape_timer_reset(void) ;
extern void mape_timer_start(void) ;
extern void mape_timer_stop(void) ;
extern void mape_timer_report(char *) ;
extern void mape_spacer_reset(void) ;
extern void mape_spacer_start(void) ;
extern void mape_spacer_stop(void) ;
extern void mape_spacer_report(char *) ;

/*for implication utility*/
extern void mape_imp_reset(int (*f)(), char *arg) ;
extern void mape_imp_start(void) ;
extern void mape_imp_push(node_t *) ;

/*for contrallability analysis */
extern void mape_ctrl_get_all_node(void) ;
extern int mape_get_node_C0(node_t *) ;
extern int mape_get_node_C1(node_t *) ;
extern int mape_ctrl_max(void) ;

/*mape curlib*/
extern mape_curlib_gate_t *mape_curlib_find_gate(char *) ;
double mape_curlib_value(mape_curlib_gate_t *, mape_curlib_param_type_t, double) ;
double mape_curlib_loadg_value(mape_curlib_gate_t *, mape_curlib_param_type_t, char*) ;
extern void mape_curlib_set_unit_mode(int) ;
extern void mape_curlib_set_various_mode(int) ;

/*mape cur*/
extern double mape_cur_max_current(network_t *, double *, lsList) ;
extern void mape_cur_accumulate_current(network_t *, lsList) ;
extern void mape_itr_push_untran(node_t *) ;
extern lsList mape_cur_top_trans_values(node_t *) ;
extern int mape_itr_node_sort_value(node_t *) ;
extern node_t * mape_itr_fetch_untran( int (*f)(), node_t *) ;
extern node_t * mape_itr_backtrace(node_t *) ;
extern lsList mape_cur_pop_trans_values(node_t *) ;
extern lsList mape_cur_top_vol_points(node_t *) ;
extern mape_cur_node_value_t *mape_cur_top_node_value(node_t *) ;
extern lsList mape_cur_pop_vol_points(node_t *) ;
extern double mape_cur_top_node_delay(node_t *) ;
extern double mape_cur_simulation_hv_time(node_t *, double) ;
extern double mape_cur_simulation_hv_time_s(node_t *, double) ;	// simple version
extern double mape_cur_node_delay(node_t *, int) ;
extern int mape_cur_imp_do(node_t *, char *) ;
extern int mape_cur_simulate_node_vx(node_t *, node_t *, mape_node_value_t) ;
extern void mape_cur_simulate_node_v(node_t *, node_t *, mape_node_value_t) ;
extern double mape_cur_node_voltage(node_t *, double) ;
extern double mape_cur_triangle_value(double, double, double, double, double) ;
extern mape_curlib_gate_t * mape_cur_curlib_gate(node_t *) ;
extern double mape_cur_node_loading(node_t *) ;
extern int mape_cur_simulation_critical_time(node_t *, double *, int *) ;
extern mape_cur_point_t *mape_cur_create_cur_point_t(double, double) ;
extern double mape_cur_point_value(lsList, double) ;
extern lsList mape_cur_cone_pi(void) ;

/* mape group */
lsList mape_group_get_groups(network_t *) ;

/* mape curitr */
extern double mape_curitr(network_t *, double *, lsList);
extern int mape_curitr_imp_do(node_t *, char *) ;

/* mape sa */
void mape_sa_set(double, double, char * (*)(void), void (*destroy)(char *), double (*cost)(char *),
                 void (*move)(char *, char *), int (*equilibrum)(int, int, int), int (*stop)(double, int, double),
		 void (*accept)(int)) ;
void mape_sa_start(char **) ;

/*mape plt */
extern 	void 	mape_saplt_init_plt(network_t * network) ;
extern 	void 	mape_saplt_dump(void) ;
extern 	char *	mape_saplt_sa_create(void) ;
extern 	void 	mape_saplt_sa_destroy(char *) ;
extern 	void 	mape_saplt_move(char *, char *) ;
extern 	void 	mape_saplt_move_s(char *, char *) ;
extern  int     mape_saplt_sa_equilibrum(int, int, int) ;
extern  int     mape_saplt_sa_stop(double, int, double) ;
extern 	node_t* mape_saplt_index_node(int row, int col) ;
extern 	void	mape_saplt_plt_size(int *, int *) ;
extern 	void	mape_saplt_switched_node(node_t **, node_t **) ; 
extern	void 	mape_saplt_set_node_array(node_t **, int) ;
extern  double	mape_saplt_wire_length(char *) ;
extern  mape_node_plt_t * mape_create_plt_t(void) ;
extern  void 	mape_saplt_place_node(node_t *, int, int) ;
extern 	void 	mape_saplt_alloc_array(int) ;
extern	void 	mape_saplt_set_exnode(node_t*, node_t *) ;
extern 	double 	mape_saplt_cost(char *) ;
extern 	double 	mape_saplt_prob_cost(char *) ;
extern 	void 	mape_saplt_sa_accept(int) ;
extern 	void 	mape_saplt_sa_accept_s(int) ;
extern 	void 	mape_saplt_sa_accept_p(int) ;
extern 	void 	mape_saplt_exchange_index(int, int, int, int) ;
extern 	void 	mape_saplt_init_plt(network_t *) ;
extern 	void 	mape_saplt_set_exindex(int, int, int, int) ;
extern  double	mape_saplt_cal_ssc(network_t *, double *, double *, int) ;

/*mape sassc */
extern 	void 	mape_sassc_group_start(int) ;
extern 	int 	mape_sassc_group_next(lsList) ;
extern 	double	mape_sassc_group_max_ssc(lsList, int, double *, lsList) ;

/* mape curga*/
extern double mape_curga(network_t *) ;

/*mape cursa */
extern double mape_cursa(network_t *, double *, lsList ) ;

/*mape mspplt*/
extern void mape_mspplt_random_same_group(int*, int*, int *, int *, int) ;
extern int mape_mspplt_rc_group(int, int) ;
extern int mape_mapplt_null_node(node_t *) ;
extern void mape_mspplt_st_possibility(network_t *) ;
extern int mape_mspplt_st_value_cmp(lsGeneric, lsGeneric) ;
extern void mape_mspplt_node_index_input(int, int, int *) ; 
extern mape_node_value_t mape_mspplt_index_simulate_node(node_t *, int *) ;

extern int plt_size ;

/*mape tatpg*/
extern void mape_tatpg(network_t *) ;
extern double mape_tatpg_get_target_time(void) ;
extern void mape_tatpg_assign_remaining_pi(network_t *, double *) ;

/*mape pbssce*/
extern void mape_pbssce_st_possibility(network_t *) ;
extern void mape_pbssce_build_coswitch_db(network_t *) ;
extern double mape_pbssce_itr_estimate_current(network_t *, lsList) ;
extern void mape_pbssce_node_destroy_cantl(node_t *node) ;

#endif /*end of MAPE_INT_H */
