BEGIN{
	ind1 = 0 ;
	ind2 = 0 ;
	total_error = 0;
	total_current = 0 ;
	lest_current = 2000 ;
}

/PBSSCE/{
	ind1 ++ ;
	x[ind1] = -$5 ;
	if(x[ind1] >= 1500)
		x[ind1] = 200.00 ;
}

/Generation=50/{
	ind2 ++ ;
	split($3, a, "=") ; 
	y[ind2] = a[2] ;
}

/Cluster/{
	ind1 ++ ;
	y[ind1] = -$4 ;
}

END{
	if(ind1 != ind2){
		printf("Error: %d != %d\n", ind1, ind2) ;
	}else {
		printf("______________________________\n") ;
		printf("\tSSC1\tSSC2\tDiff.\n") ;
		printf("______________________________\n") ;
		for(i=1;i<=ind1;i++){
			if(y[i] > 0) error = (x[i]-y[i])*100/(y[i]) ;
			printf("Group%d\t%.2lf\t%.2lf\t%.2lf%%\n", i, y[i], x[i], error) ;
			if(error > 0)
				total_error += error
			else 
				total_error += -error
			total_current += y[i] ;
			if(y[i] < lest_current)
				lest_current = y[i] ;
		}
		tmp = (1530 - total_current/ind1)*100/1530 ;
		printf("Avg current = %.2lf, %.2lf%% percent less than 1530\n", total_current/ind1, tmp) ;
		tmp = (1530 - lest_current) * 100 /1530 ;
		printf("lest current = %.2lf, %.2lf%% percent less than 1530\n", lest_current, tmp) ; 

		printf("______________________________\n") ;
		printf("Average error\t%.2lf%%\n", total_error/ind1) ;

		printf("a=[") ;
		for(i=1;i<=ind1;i++){
			if(i != ind1)
				printf("%.2lf, ", x[i]) ;
			else 
				printf("%.2lf];\n", x[i]) ;
		}
		printf("b=[") ;
		for(i=1;i<=ind1;i++){
			if(i != ind1)
				printf("%.2lf, ", y[i]) ;
			else 
				printf("%.2lf];\n", y[i]) ;
		}
		printf("u=[0, 2000] ;\nv=[0, 2000] \nplot(a, b, '*', u, v, '-') \n") ;
		printf("xlabel('Estimation') ;\n") ;
		printf("ylabel('GA') ;\n") ;
	}
}
