BEGIN{
	ind1 = 0 ;
	ind2 = 0 ;
	total_error = 0;
}

/PBSSCE/{
	ind1 ++ ;
	x[ind1] = -$5 ;
	if(x[ind1] >= 1500)
		x[ind1] = 200.00 ;
}

/Generation=50/{
	ind2 ++ ;
	split($3, a, "=") ; 
	x[ind2] = a[2] ;
}

/Cluster/{
	ind1 ++ ;
	y[ind1] = -$4 ;
}

END{
	for(i=1;i<=ind2/2;i++)
		y[i] = x[i+ind2/2] ;

	ind1 = ind2/2 ;
	ind2 = ind2/2 ;

	if(ind1 != ind2){
		printf("Error: %d != %d\n", ind1, ind2) ;
	}else {
		printf("______________________________\n") ;
		printf("\tSSC1\tSSC2\tDiff.\n") ;
		printf("______________________________\n") ;
		for(i=1;i<=ind1;i++){
			if(y[i] > 0) error = (x[i]-y[i])*100/(y[i]) ;
			printf("Group%d\t%.2lf\t%.2lf\t%.2lf%%\n", i, y[i], x[i], error) ;
			if(error > 0)
				total_error += error
			else 
				total_error += -error
		}
		printf("______________________________\n") ;
		printf("Average error\t%.2lf%%\n", total_error/ind1) ;

		printf("a=[") ;
		for(i=1;i<=ind1;i++){
			if(i != ind1)
				printf("%.2lf, ", x[i]) ;
			else 
				printf("%.2lf];\n", x[i]) ;
		}
		printf("b=[") ;
		for(i=1;i<=ind1;i++){
			if(i != ind1)
				printf("%.2lf, ", y[i]) ;
			else 
				printf("%.2lf];\n", y[i]) ;
		}
		printf("u=[0, 1200] ;\nv=[0, 1200] \nplot(a, b, '*', u, v, '-') \n") ;
		printf("xlabel('Estimation') ;\n") ;
		printf("ylabel('GA') ;\n") ;
	}
}
