BEGIN{
	ind1 = 0 ;
	ind2 = 0 ;
	total_error = 0;
	last_gen = -100.0 ;
}

/Generation=/{
	if($0 ~ /Generation=0/){
		if(last_gen > -50){ 
			ind2 ++ ;
			x[ind2] = last_gen ;
		}
	}
	split($3, a, "=") ; 
	last_gen = a[2] ;
}

/Maximum current estimation/{
	ind1 ++ ;
	y[ind1] = -$4 ;
}

END{
	ind2 ++ ;
	x[ind2] = last_gen ;

	if(ind1 != ind2){
		printf("Error: %d != %d\n", ind1, ind2) ;
	}else {
		printf("______________________________\n") ;
		printf("\tSSC1\tSSC2\tDiff.\n") ;
		printf("______________________________\n") ;
		for(i=1;i<=ind1;i++){
			if(y[i] > 0) error = (x[i]-y[i])*100/(y[i]) ;
			printf("Grp%d\t%.2lf\t%.2lf\t%.2lf%%\n", i, y[i], x[i], error) ;
			if(error > 0)
				total_error += error
			else 
				total_error += -error
		}
		printf("______________________________\n") ;
		printf("Average error\t%.2lf%%\n", total_error/ind1) ;

		printf("a=[") ;
		for(i=1;i<=ind1;i++){
			if(i != ind1)
				printf("%.2lf, ", x[i]) ;
			else 
				printf("%.2lf];\n", x[i]) ;
		}
		printf("b=[") ;
		for(i=1;i<=ind1;i++){
			if(i != ind1)
				printf("%.2lf, ", y[i]) ;
			else 
				printf("%.2lf];\n", y[i]) ;
		}
		printf("u=[0, 1200] ;\nv=[0, 1200] \nplot(a, b, '*', u, v, '-') \n") ;
		printf("xlabel('Estimation') ;\n") ;
		printf("ylabel('GA') ;\n") ;
	}
}
