
# line 11 "readlib.y"
/* file @(#)readlib.y	1.2                      */
/* last modified on 6/13/91 at 17:46:40   */
#include <setjmp.h>
#include "genlib_int.h"

#undef GENLIB_yywrap 
static int input();
static int unput();
static int GENLIB_yywrap();

FILE *gl_out_file;
#ifdef YYBYACC
extern char *GENLIB_yytext;
#else
#if defined(hpux) || defined(__osf__)
extern unsigned char GENLIB_yytext[];
#else
extern char GENLIB_yytext[];
#endif
#endif

static int global_use_nor;
static function_t *global_fct;


# line 37 "readlib.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
    tree_node_t *nodeval;
    char *strval;
    double realval; 
    pin_info_t *pinval;
    function_t *functionval;
    latch_info_t *latchval;
    constraint_info_t *constrval;
} YYSTYPE;
# define OPR_OR 257
# define OPR_AND 258
# define CONST1 259
# define CONST0 260
# define IDENTIFIER 261
# define LPAREN 262
# define REAL 263
# define OPR_NOT 264
# define OPR_NOT_POST 265
# define GATE 266
# define PIN 267
# define SEMI 268
# define ASSIGN 269
# define RPAREN 270
# define LATCH 271
# define CONTROL 272
# define CONSTRAINT 273
# define SEQ 274

#include <inttypes.h>

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#define	YYCONST	const
#else
#include <malloc.h>
#include <memory.h>
#define	YYCONST
#endif

#include <values.h>

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
#ifndef GENLIB_yyerror
#if defined(__cplusplus)
	void GENLIB_yyerror(YYCONST char *);
#endif
#endif
#ifndef GENLIB_yylex
	int GENLIB_yylex(void);
#endif
	int GENLIB_yyparse(void);
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif

#define GENLIB_yyclearin GENLIB_yychar = -1
#define GENLIB_yyerrok GENLIB_yyerrflag = 0
extern int GENLIB_yychar;
extern int GENLIB_yyerrflag;
YYSTYPE GENLIB_yylval;
YYSTYPE GENLIB_yyval;
typedef int GENLIB_yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int GENLIB_yy_GENLIB_yys[YYMAXDEPTH], *GENLIB_yys = GENLIB_yy_GENLIB_yys;
YYSTYPE GENLIB_yy_GENLIB_yyv[YYMAXDEPTH], *GENLIB_yyv = GENLIB_yy_GENLIB_yyv;
#else	/* user does initial allocation */
int *GENLIB_yys;
YYSTYPE *GENLIB_yyv;
#endif
static int GENLIB_yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 263 "readlib.y"

#include "readliblex.c"

static char *file_string;
static int file_mode;
static int nbuffer;
static char buffer[20];
static jmp_buf jmpbuf;

#ifndef FLEX_SCANNER
static int
input()
{
    register int c;

    if (nbuffer > 0) {
	c = buffer[--nbuffer];
    } else {
	if (file_mode) {
	    c = getc(GENLIB_yyin);
	} else {
	    c = *file_string;
	    if (c != 0) file_string++;
	}
    }
    if (c == '\n') read_lineno++;
    if (c == EOF) c = 0;
    return c;
}


static int
unput(c)
int c;
{
    if (nbuffer < 20) buffer[nbuffer++] = c;
    if (c == '\n') read_lineno--;
    return c;
}
#else

char *genlib_inp_ptr;
char* genlib_inp_lim;

int genlib_input(char* buf, int max_size)
{
    char c;
    int i, n;

    if (! file_mode) {
	if (max_size > (genlib_inp_lim - genlib_inp_ptr))
	    n = genlib_inp_lim - genlib_inp_ptr;
	else 
	    n = max_size;	
	if (n > 0) {
	    for (i = 0; i < n; i++)
		if (buf[i] == '\n') {
		    read_lineno++;
		    i++;
		    break;
		}
	    memcpy (buf, genlib_inp_ptr, i);
	    genlib_inp_ptr += i;
	}
    } else {
	c = getc(GENLIB_yyin);
	if (c == '\n') read_lineno++;
	buf[0] = (c == EOF) ? (n = 0, YY_NULL) : (n = 1, c);
    }
    return n;
}
#endif

static int
library_setup_file(fp, filename)
FILE *fp;
char *filename;
{
    GENLIB_yyin = fp;
#ifdef FLEX_SCANNER 
    GENLIB_yy_switch_to_buffer(
                 GENLIB_yy_create_buffer( GENLIB_yyin, YY_BUF_SIZE ) );
    GENLIB_yyrestart(GENLIB_yyin); 
    BEGIN(INITIAL);
#endif
    file_mode = 1;
    nbuffer = 0;
    read_register_filename(filename);
}


static int
library_setup_string(string)
char *string;
{
    file_string = string;
    file_mode = 0;
#ifdef FLEX_SCANNER
    GENLIB_yy_switch_to_buffer(
                 GENLIB_yy_create_buffer( GENLIB_yyin, YY_BUF_SIZE ) );
    GENLIB_yyrestart(GENLIB_yyin); 
    genlib_inp_lim = string + strlen(string);
    genlib_inp_ptr = string;
#endif
    nbuffer = 0;
    read_register_filename(NIL(char));
}


int
GENLIB_yyerror(errmsg)
char *errmsg;
{
    if (errmsg != 0) read_error(errmsg);
    longjmp(jmpbuf, 1);
}

#undef GENLIB_yywrap 
static int
GENLIB_yywrap()
{
    return 1;
}

int
gl_convert_genlib_to_blif(filename, use_nor)
char *filename;
int use_nor;
{
    FILE *fp;

    error_init();
    if ((fp = fopen(filename, "r")) == NULL) {
	perror(filename);
	return 0;
    }
    library_setup_file(fp, filename);
    gl_out_file = stdout;

    global_fct = 0;		/* not used here, just to check for error */
    global_use_nor = use_nor;

    if (setjmp(jmpbuf)) {
	return 0;
    } else {
	(void) GENLIB_yyparse();
	if (global_fct != 0) GENLIB_yyerror("syntax error");
	return 1;
    }
}



int
genlib_parse_library(infp, infilename, outfp, use_nor)
FILE *infp;
char *infilename;
FILE *outfp;
int use_nor;
{
    error_init();
    library_setup_file(infp, infilename);
    gl_out_file = outfp;
    global_fct = 0;		/* not used here, just to check for error */
    global_use_nor = use_nor;

    if (setjmp(jmpbuf)) {
	return 0;
    } else {
	(void) GENLIB_yyparse();
	if (global_fct != 0) GENLIB_yyerror("syntax error");
	return 1;
    }
}


int
gl_convert_expression_to_tree(string, tree, name)
char *string;
tree_node_t **tree;
char **name;
{
    error_init();
    global_fct = 0;
    library_setup_string(string);

    if (setjmp(jmpbuf)) {
	return 0;
    } else {
	(void) GENLIB_yyparse();
	if (global_fct == 0) GENLIB_yyerror("syntax error");
	*tree = global_fct->tree;
	*name = global_fct->name;
	return 1;
    }
}
static YYCONST GENLIB_yytabelem GENLIB_yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 33
# define YYLAST 137
static YYCONST GENLIB_yytabelem GENLIB_yyact[]={

    23,    24,    18,    17,     5,    14,     6,    15,    26,    53,
    44,    10,    37,    33,    23,    24,    18,    17,     5,    14,
     6,    15,    26,    37,     8,    22,    15,    26,    20,     9,
    39,    24,    18,    17,     5,    14,     6,    15,    26,    18,
    17,     5,    14,     6,    15,    42,    56,     5,     5,     6,
     6,    19,    25,    40,    34,     7,     2,     1,     3,    38,
    55,    48,    52,    13,    21,    43,    36,    27,    28,    46,
     0,     0,     0,     0,     0,     0,    31,    32,    29,     0,
    30,     0,    16,     4,     0,    35,     0,     0,     0,     0,
     0,    11,    12,     0,     0,     0,     0,     0,    51,     0,
     0,    54,     4,    57,     4,     0,    59,    58,     0,    60,
    61,    62,    63,    64,    65,    66,     0,    67,    68,    69,
    41,     0,    45,    47,     0,     0,     0,    49,    50,     0,
     0,     0,     0,     0,     0,     0,    41 };
static YYCONST GENLIB_yytabelem GENLIB_yypact[]={

  -214,-10000000,  -242,-10000000,  -258,-10000000,-10000000,-10000000,  -214,  -214,
  -220,  -235,  -235,  -243,  -220,  -220,-10000000,-10000000,-10000000,  -214,
-10000000,  -214,-10000000,  -220,  -220,  -238,-10000000,  -257,-10000000,-10000000,
-10000000,  -227,  -238,-10000000,  -255,  -244,-10000000,  -213,  -262,  -214,
  -214,-10000000,-10000000,-10000000,  -214,  -214,  -235,-10000000,  -264,  -235,
  -215,  -235,-10000000,  -213,  -235,-10000000,-10000000,  -235,  -235,  -235,
  -235,  -235,  -235,  -235,-10000000,  -235,  -235,  -235,-10000000,-10000000 };
static YYCONST GENLIB_yytabelem GENLIB_yypgo[]={

     0,    52,    82,    53,    69,    51,    54,    66,    58,    65,
    62,    61,    60,    59,    57,    56,    55 };
static YYCONST GENLIB_yytabelem GENLIB_yyr1[]={

     0,    14,    14,    15,    15,    16,    16,     6,     6,     7,
     4,     3,     3,     8,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     2,     2,     5,     9,     9,    11,    11,
    10,    13,    12 };
static YYCONST GENLIB_yytabelem GENLIB_yyr2[]={

     0,     2,     3,     0,     4,    11,    17,     1,     5,    19,
     3,     3,     3,     9,     7,     7,     5,     7,     5,     5,
     3,     3,     3,     3,     3,     3,     1,    17,     1,     5,
     9,     9,     3 };
static YYCONST GENLIB_yytabelem GENLIB_yychk[]={

-10000000,   -14,   -15,    -8,    -2,   261,   263,   -16,   266,   271,
   269,    -2,    -2,    -1,   262,   264,    -2,   260,   259,    -5,
   263,    -5,   268,   257,   258,    -1,   265,    -1,    -1,    -8,
    -8,    -1,    -1,   270,    -6,    -6,    -7,   267,   -13,   274,
    -3,    -2,   258,    -9,   272,    -2,    -4,    -2,   -11,    -2,
    -2,    -5,   -10,   273,    -5,   -12,   261,    -5,    -3,    -5,
    -5,    -5,    -5,    -5,    -5,    -5,    -5,    -5,    -5,    -5 };
static YYCONST GENLIB_yytabelem GENLIB_yydef[]={

     3,    -2,     1,     2,     0,    23,    24,     4,     0,     0,
     0,     0,     0,     0,     0,     0,    20,    21,    22,     0,
    25,     0,    13,     0,     0,    16,    19,     0,    18,     7,
     7,    14,    15,    17,     5,     0,     8,     0,    26,     0,
     0,    11,    12,    28,     0,     0,     0,    10,     6,     0,
     0,     0,    29,     0,     0,    31,    32,     0,     0,     0,
     0,     0,     0,     0,    30,     0,     0,     0,     9,    27 };
typedef struct
#ifdef __cplusplus
	GENLIB_yytoktype
#endif
{ char *t_name; int t_val; } GENLIB_yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

GENLIB_yytoktype GENLIB_yytoks[] =
{
	"OPR_OR",	257,
	"OPR_AND",	258,
	"CONST1",	259,
	"CONST0",	260,
	"IDENTIFIER",	261,
	"LPAREN",	262,
	"REAL",	263,
	"OPR_NOT",	264,
	"OPR_NOT_POST",	265,
	"GATE",	266,
	"PIN",	267,
	"SEMI",	268,
	"ASSIGN",	269,
	"RPAREN",	270,
	"LATCH",	271,
	"CONTROL",	272,
	"CONSTRAINT",	273,
	"SEQ",	274,
	"-unknown-",	-1	/* ends search */
};

char * GENLIB_yyreds[] =
{
	"-no such reduction-",
	"hack : gates",
	"hack : function",
	"gates : /* empty */",
	"gates : gates gate_info",
	"gate_info : GATE name real function pins",
	"gate_info : LATCH name real function pins latch clock constraints",
	"pins : /* empty */",
	"pins : pins pin_info",
	"pin_info : PIN pin_name pin_phase real real real real real real",
	"pin_phase : name",
	"pin_name : name",
	"pin_name : OPR_AND",
	"function : name ASSIGN expr SEMI",
	"expr : expr OPR_OR expr",
	"expr : expr OPR_AND expr",
	"expr : expr expr",
	"expr : LPAREN expr RPAREN",
	"expr : OPR_NOT expr",
	"expr : expr OPR_NOT_POST",
	"expr : name",
	"expr : CONST0",
	"expr : CONST1",
	"name : IDENTIFIER",
	"name : REAL",
	"real : REAL",
	"clock : /* empty */",
	"clock : CONTROL name real real real real real real",
	"constraints : /* empty */",
	"constraints : constraints constraint",
	"constraint : CONSTRAINT pin_name real real",
	"latch : SEQ name name type",
	"type : IDENTIFIER",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.16	99/01/20 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto GENLIB_yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( GENLIB_yychar >= 0 || ( GENLIB_yyr2[ GENLIB_yytmp ] >> 1 ) != 1 )\
	{\
		GENLIB_yyerror( "syntax error - cannot backup" );\
		goto GENLIB_yyerrlab;\
	}\
	GENLIB_yychar = newtoken;\
	GENLIB_yystate = *GENLIB_yyps;\
	GENLIB_yylval = newvalue;\
	goto GENLIB_yynewstate;\
}
#define YYRECOVERING()	(!!GENLIB_yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * GENLIB_yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, GENLIB_yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, GENLIB_yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int GENLIB_yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *GENLIB_yypv;			/* top of value stack */
int *GENLIB_yyps;			/* top of state stack */

int GENLIB_yystate;			/* current state */
int GENLIB_yytmp;			/* extra var (lasts between blocks) */

int GENLIB_yynerrs;			/* number of errors */
int GENLIB_yyerrflag;			/* error recovery flag */
int GENLIB_yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		GENLIB_yycvtok(GENLIB_yylex())
/*
** GENLIB_yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int GENLIB_yycvtok(int i)
#else
int GENLIB_yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( GENLIB_yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = GENLIB_yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return GENLIB_yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		GENLIB_yylex()
#endif/*!YYNMBCHARS*/

/*
** GENLIB_yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int GENLIB_yyparse(void)
#else
int GENLIB_yyparse()
#endif
{
	register YYSTYPE *GENLIB_yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto GENLIB_yyerrlab;
		case 2: goto GENLIB_yynewstate;
	}
#endif

	/*
	** Initialize externals - GENLIB_yyparse may be called more than once
	*/
	GENLIB_yypv = &GENLIB_yyv[-1];
	GENLIB_yyps = &GENLIB_yys[-1];
	GENLIB_yystate = 0;
	GENLIB_yytmp = 0;
	GENLIB_yynerrs = 0;
	GENLIB_yyerrflag = 0;
	GENLIB_yychar = -1;

#if YYMAXDEPTH <= 0
	if (GENLIB_yymaxdepth <= 0)
	{
		if ((GENLIB_yymaxdepth = YYEXPAND(0)) <= 0)
		{
			GENLIB_yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *GENLIB_yy_pv;	/* top of value stack */
		register int *GENLIB_yy_ps;		/* top of state stack */
		register int GENLIB_yy_state;		/* current state */
		register int  GENLIB_yy_n;		/* internal state number info */
	goto GENLIB_yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	GENLIB_yynewstate:
		GENLIB_yy_pv = GENLIB_yypv;
		GENLIB_yy_ps = GENLIB_yyps;
		GENLIB_yy_state = GENLIB_yystate;
		goto GENLIB_yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	GENLIB_yystack:
		GENLIB_yy_pv = GENLIB_yypv;
		GENLIB_yy_ps = GENLIB_yyps;
		GENLIB_yy_state = GENLIB_yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	GENLIB_yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( GENLIB_yydebug )
		{
			register int GENLIB_yy_i;

			printf( "State %d, token ", GENLIB_yy_state );
			if ( GENLIB_yychar == 0 )
				printf( "end-of-file\n" );
			else if ( GENLIB_yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( GENLIB_yy_i = 0; GENLIB_yytoks[GENLIB_yy_i].t_val >= 0;
					GENLIB_yy_i++ )
				{
					if ( GENLIB_yytoks[GENLIB_yy_i].t_val == GENLIB_yychar )
						break;
				}
				printf( "%s\n", GENLIB_yytoks[GENLIB_yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++GENLIB_yy_ps >= &GENLIB_yys[ GENLIB_yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			long GENLIB_yyps_index = (GENLIB_yy_ps - GENLIB_yys);
			long GENLIB_yypv_index = (GENLIB_yy_pv - GENLIB_yyv);
			long GENLIB_yypvt_index = (GENLIB_yypvt - GENLIB_yyv);
			int GENLIB_yynewmax;
#ifdef YYEXPAND
			GENLIB_yynewmax = YYEXPAND(GENLIB_yymaxdepth);
#else
			GENLIB_yynewmax = 2 * GENLIB_yymaxdepth;	/* double table size */
			if (GENLIB_yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newGENLIB_yys = (char *)YYNEW(int);
				char *newGENLIB_yyv = (char *)YYNEW(YYSTYPE);
				if (newGENLIB_yys != 0 && newGENLIB_yyv != 0)
				{
					GENLIB_yys = YYCOPY(newGENLIB_yys, GENLIB_yys, int);
					GENLIB_yyv = YYCOPY(newGENLIB_yyv, GENLIB_yyv, YYSTYPE);
				}
				else
					GENLIB_yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				GENLIB_yys = YYENLARGE(GENLIB_yys, int);
				GENLIB_yyv = YYENLARGE(GENLIB_yyv, YYSTYPE);
				if (GENLIB_yys == 0 || GENLIB_yyv == 0)
					GENLIB_yynewmax = 0;	/* failed */
			}
#endif
			if (GENLIB_yynewmax <= GENLIB_yymaxdepth)	/* tables not expanded */
			{
				GENLIB_yyerror( "yacc stack overflow" );
				YYABORT;
			}
			GENLIB_yymaxdepth = GENLIB_yynewmax;

			GENLIB_yy_ps = GENLIB_yys + GENLIB_yyps_index;
			GENLIB_yy_pv = GENLIB_yyv + GENLIB_yypv_index;
			GENLIB_yypvt = GENLIB_yyv + GENLIB_yypvt_index;
		}
		*GENLIB_yy_ps = GENLIB_yy_state;
		*++GENLIB_yy_pv = GENLIB_yyval;

		/*
		** we have a new state - find out what to do
		*/
	GENLIB_yy_newstate:
		if ( ( GENLIB_yy_n = GENLIB_yypact[ GENLIB_yy_state ] ) <= YYFLAG )
			goto GENLIB_yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		GENLIB_yytmp = GENLIB_yychar < 0;
#endif
		if ( ( GENLIB_yychar < 0 ) && ( ( GENLIB_yychar = YYLEX() ) < 0 ) )
			GENLIB_yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( GENLIB_yydebug && GENLIB_yytmp )
		{
			register int GENLIB_yy_i;

			printf( "Received token " );
			if ( GENLIB_yychar == 0 )
				printf( "end-of-file\n" );
			else if ( GENLIB_yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( GENLIB_yy_i = 0; GENLIB_yytoks[GENLIB_yy_i].t_val >= 0;
					GENLIB_yy_i++ )
				{
					if ( GENLIB_yytoks[GENLIB_yy_i].t_val == GENLIB_yychar )
						break;
				}
				printf( "%s\n", GENLIB_yytoks[GENLIB_yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( GENLIB_yy_n += GENLIB_yychar ) < 0 ) || ( GENLIB_yy_n >= YYLAST ) )
			goto GENLIB_yydefault;
		if ( GENLIB_yychk[ GENLIB_yy_n = GENLIB_yyact[ GENLIB_yy_n ] ] == GENLIB_yychar )	/*valid shift*/
		{
			GENLIB_yychar = -1;
			GENLIB_yyval = GENLIB_yylval;
			GENLIB_yy_state = GENLIB_yy_n;
			if ( GENLIB_yyerrflag > 0 )
				GENLIB_yyerrflag--;
			goto GENLIB_yy_stack;
		}

	GENLIB_yydefault:
		if ( ( GENLIB_yy_n = GENLIB_yydef[ GENLIB_yy_state ] ) == -2 )
		{
#if YYDEBUG
			GENLIB_yytmp = GENLIB_yychar < 0;
#endif
			if ( ( GENLIB_yychar < 0 ) && ( ( GENLIB_yychar = YYLEX() ) < 0 ) )
				GENLIB_yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( GENLIB_yydebug && GENLIB_yytmp )
			{
				register int GENLIB_yy_i;

				printf( "Received token " );
				if ( GENLIB_yychar == 0 )
					printf( "end-of-file\n" );
				else if ( GENLIB_yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( GENLIB_yy_i = 0;
						GENLIB_yytoks[GENLIB_yy_i].t_val >= 0;
						GENLIB_yy_i++ )
					{
						if ( GENLIB_yytoks[GENLIB_yy_i].t_val
							== GENLIB_yychar )
						{
							break;
						}
					}
					printf( "%s\n", GENLIB_yytoks[GENLIB_yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register YYCONST int *GENLIB_yyxi = GENLIB_yyexca;

				while ( ( *GENLIB_yyxi != -1 ) ||
					( GENLIB_yyxi[1] != GENLIB_yy_state ) )
				{
					GENLIB_yyxi += 2;
				}
				while ( ( *(GENLIB_yyxi += 2) >= 0 ) &&
					( *GENLIB_yyxi != GENLIB_yychar ) )
					;
				if ( ( GENLIB_yy_n = GENLIB_yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( GENLIB_yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( GENLIB_yyerrflag )
			{
			case 0:		/* new error */
				GENLIB_yyerror( "syntax error" );
				goto skip_init;
			GENLIB_yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				GENLIB_yy_pv = GENLIB_yypv;
				GENLIB_yy_ps = GENLIB_yyps;
				GENLIB_yy_state = GENLIB_yystate;
			skip_init:
				GENLIB_yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				GENLIB_yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( GENLIB_yy_ps >= GENLIB_yys )
				{
					GENLIB_yy_n = GENLIB_yypact[ *GENLIB_yy_ps ] + YYERRCODE;
					if ( GENLIB_yy_n >= 0 && GENLIB_yy_n < YYLAST &&
						GENLIB_yychk[GENLIB_yyact[GENLIB_yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						GENLIB_yy_state = GENLIB_yyact[ GENLIB_yy_n ];
						goto GENLIB_yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( GENLIB_yydebug )
						printf( _POP_, *GENLIB_yy_ps,
							GENLIB_yy_ps[-1] );
#	undef _POP_
#endif
					GENLIB_yy_ps--;
					GENLIB_yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( GENLIB_yydebug )
				{
					register int GENLIB_yy_i;

					printf( "Error recovery discards " );
					if ( GENLIB_yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( GENLIB_yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( GENLIB_yy_i = 0;
							GENLIB_yytoks[GENLIB_yy_i].t_val >= 0;
							GENLIB_yy_i++ )
						{
							if ( GENLIB_yytoks[GENLIB_yy_i].t_val
								== GENLIB_yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							GENLIB_yytoks[GENLIB_yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( GENLIB_yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				GENLIB_yychar = -1;
				goto GENLIB_yy_newstate;
			}
		}/* end if ( GENLIB_yy_n == 0 ) */
		/*
		** reduction by production GENLIB_yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( GENLIB_yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				GENLIB_yy_n, GENLIB_yyreds[ GENLIB_yy_n ] );
#endif
		GENLIB_yytmp = GENLIB_yy_n;			/* value to switch over */
		GENLIB_yypvt = GENLIB_yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using GENLIB_yy_state here as temporary
		** register variable, but why not, if it works...
		** If GENLIB_yyr2[ GENLIB_yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto GENLIB_yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int GENLIB_yy_len = GENLIB_yyr2[ GENLIB_yy_n ];

			if ( !( GENLIB_yy_len & 01 ) )
			{
				GENLIB_yy_len >>= 1;
				GENLIB_yyval = ( GENLIB_yy_pv -= GENLIB_yy_len )[1];	/* $$ = $1 */
				GENLIB_yy_state = GENLIB_yypgo[ GENLIB_yy_n = GENLIB_yyr1[ GENLIB_yy_n ] ] +
					*( GENLIB_yy_ps -= GENLIB_yy_len ) + 1;
				if ( GENLIB_yy_state >= YYLAST ||
					GENLIB_yychk[ GENLIB_yy_state =
					GENLIB_yyact[ GENLIB_yy_state ] ] != -GENLIB_yy_n )
				{
					GENLIB_yy_state = GENLIB_yyact[ GENLIB_yypgo[ GENLIB_yy_n ] ];
				}
				goto GENLIB_yy_stack;
			}
			GENLIB_yy_len >>= 1;
			GENLIB_yyval = ( GENLIB_yy_pv -= GENLIB_yy_len )[1];	/* $$ = $1 */
			GENLIB_yy_state = GENLIB_yypgo[ GENLIB_yy_n = GENLIB_yyr1[ GENLIB_yy_n ] ] +
				*( GENLIB_yy_ps -= GENLIB_yy_len ) + 1;
			if ( GENLIB_yy_state >= YYLAST ||
				GENLIB_yychk[ GENLIB_yy_state = GENLIB_yyact[ GENLIB_yy_state ] ] != -GENLIB_yy_n )
			{
				GENLIB_yy_state = GENLIB_yyact[ GENLIB_yypgo[ GENLIB_yy_n ] ];
			}
		}
					/* save until reenter driver code */
		GENLIB_yystate = GENLIB_yy_state;
		GENLIB_yyps = GENLIB_yy_ps;
		GENLIB_yypv = GENLIB_yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( GENLIB_yytmp )
	{
		
case 2:
# line 67 "readlib.y"
{global_fct = GENLIB_yypvt[-0].functionval; } break;
case 5:
# line 75 "readlib.y"
{ 
			if (! gl_convert_gate_to_blif(GENLIB_yypvt[-3].strval,GENLIB_yypvt[-2].realval,GENLIB_yypvt[-1].functionval,GENLIB_yypvt[-0].pinval,global_use_nor))
			    GENLIB_yyerror(NIL(char));
		    } break;
case 6:
# line 80 "readlib.y"
{
		      if (! gl_convert_latch_to_blif(GENLIB_yypvt[-6].strval,GENLIB_yypvt[-5].realval,GENLIB_yypvt[-4].functionval,GENLIB_yypvt[-3].pinval,global_use_nor,GENLIB_yypvt[-2].latchval,GENLIB_yypvt[-1].pinval,GENLIB_yypvt[-0].constrval))
			GENLIB_yyerror(NIL(char));
		    } break;
case 7:
# line 87 "readlib.y"
{ GENLIB_yyval.pinval = 0; } break;
case 8:
# line 89 "readlib.y"
{ GENLIB_yypvt[-0].pinval->next = GENLIB_yypvt[-1].pinval; GENLIB_yyval.pinval = GENLIB_yypvt[-0].pinval;} break;
case 9:
# line 93 "readlib.y"
{
			GENLIB_yyval.pinval = ALLOC(pin_info_t, 1);
			GENLIB_yyval.pinval->name = GENLIB_yypvt[-7].strval;
			GENLIB_yyval.pinval->phase = GENLIB_yypvt[-6].strval;
			GENLIB_yyval.pinval->value[0] = GENLIB_yypvt[-5].realval; GENLIB_yyval.pinval->value[1] = GENLIB_yypvt[-4].realval;
			GENLIB_yyval.pinval->value[2] = GENLIB_yypvt[-3].realval; GENLIB_yyval.pinval->value[3] = GENLIB_yypvt[-2].realval;
			GENLIB_yyval.pinval->value[4] = GENLIB_yypvt[-1].realval; GENLIB_yyval.pinval->value[5] = GENLIB_yypvt[-0].realval;
			GENLIB_yyval.pinval->next = 0;
		    } break;
case 10:
# line 105 "readlib.y"
{
			if (strcmp(GENLIB_yypvt[-0].strval, "INV") != 0) {
			    if (strcmp(GENLIB_yypvt[-0].strval, "NONINV") != 0) {
				if (strcmp(GENLIB_yypvt[-0].strval, "UNKNOWN") != 0) {
				    GENLIB_yyerror("bad pin phase");
				}
			    }
			}
			GENLIB_yyval.strval = GENLIB_yypvt[-0].strval;
		    } break;
case 11:
# line 117 "readlib.y"
{ GENLIB_yyval.strval = GENLIB_yypvt[-0].strval; } break;
case 12:
# line 119 "readlib.y"
{ GENLIB_yyval.strval = util_strsav(GENLIB_yytext); } break;
case 13:
# line 123 "readlib.y"
{
			GENLIB_yyval.functionval = ALLOC(function_t, 1);
			GENLIB_yyval.functionval->name = GENLIB_yypvt[-3].strval;
			GENLIB_yyval.functionval->tree = GENLIB_yypvt[-1].nodeval;
			GENLIB_yyval.functionval->next = 0;
		    } break;
case 14:
# line 132 "readlib.y"
{ 
			GENLIB_yyval.nodeval = gl_alloc_node(2);
			GENLIB_yyval.nodeval->phase = 1;
			GENLIB_yyval.nodeval->sons[0] = GENLIB_yypvt[-2].nodeval;
			GENLIB_yyval.nodeval->sons[1] = GENLIB_yypvt[-0].nodeval;
			GENLIB_yyval.nodeval->type = OR_NODE;
		    } break;
case 15:
# line 140 "readlib.y"
{
			GENLIB_yyval.nodeval = gl_alloc_node(2);
			GENLIB_yyval.nodeval->phase = 1;
			GENLIB_yyval.nodeval->sons[0] = GENLIB_yypvt[-2].nodeval;
			GENLIB_yyval.nodeval->sons[1] = GENLIB_yypvt[-0].nodeval;
			GENLIB_yyval.nodeval->type = AND_NODE;
		    } break;
case 16:
# line 148 "readlib.y"
{
			GENLIB_yyval.nodeval = gl_alloc_node(2);
			GENLIB_yyval.nodeval->phase = 1;
			GENLIB_yyval.nodeval->sons[0] = GENLIB_yypvt[-1].nodeval;
			GENLIB_yyval.nodeval->sons[1] = GENLIB_yypvt[-0].nodeval;
			GENLIB_yyval.nodeval->type = AND_NODE;
		    } break;
case 17:
# line 156 "readlib.y"
{ 
			GENLIB_yyval.nodeval = GENLIB_yypvt[-1].nodeval; 
		    } break;
case 18:
# line 160 "readlib.y"
{ 
			GENLIB_yyval.nodeval = GENLIB_yypvt[-0].nodeval; 
			GENLIB_yyval.nodeval->phase = 0; 
		    } break;
case 19:
# line 165 "readlib.y"
{ 
			GENLIB_yyval.nodeval = GENLIB_yypvt[-1].nodeval; 
			GENLIB_yyval.nodeval->phase = 0; 
		    } break;
case 20:
# line 170 "readlib.y"
{
			GENLIB_yyval.nodeval = gl_alloc_leaf(GENLIB_yypvt[-0].strval);
			FREE(GENLIB_yypvt[-0].strval);
			GENLIB_yyval.nodeval->type = LEAF_NODE;	/* hack */
			GENLIB_yyval.nodeval->phase = 1;
		    } break;
case 21:
# line 177 "readlib.y"
{
			GENLIB_yyval.nodeval = gl_alloc_leaf("0");
			GENLIB_yyval.nodeval->phase = 1;
			GENLIB_yyval.nodeval->type = ZERO_NODE;
		    } break;
case 22:
# line 183 "readlib.y"
{
			GENLIB_yyval.nodeval = gl_alloc_leaf("1");
			GENLIB_yyval.nodeval->phase = 1;
			GENLIB_yyval.nodeval->type = ONE_NODE;
		    } break;
case 23:
# line 191 "readlib.y"
{ GENLIB_yyval.strval = util_strsav(GENLIB_yytext); } break;
case 24:
# line 194 "readlib.y"
{ GENLIB_yyval.strval = util_strsav(GENLIB_yytext); } break;
case 25:
# line 198 "readlib.y"
{ GENLIB_yyval.realval = atof(GENLIB_yytext); } break;
case 26:
# line 202 "readlib.y"
{ GENLIB_yyval.pinval = 0;} break;
case 27:
# line 204 "readlib.y"
{ GENLIB_yyval.pinval = ALLOC(pin_info_t, 1);
		  GENLIB_yyval.pinval->name = GENLIB_yypvt[-6].strval;
		  GENLIB_yyval.pinval->phase = util_strsav("UNKNOWN");
		  GENLIB_yyval.pinval->value[0] = GENLIB_yypvt[-5].realval;
		  GENLIB_yyval.pinval->value[1] = GENLIB_yypvt[-4].realval;
		  GENLIB_yyval.pinval->value[2] = GENLIB_yypvt[-3].realval;
		  GENLIB_yyval.pinval->value[3] = GENLIB_yypvt[-2].realval;
		  GENLIB_yyval.pinval->value[4] = GENLIB_yypvt[-1].realval;
		  GENLIB_yyval.pinval->value[5] = GENLIB_yypvt[-0].realval;
		  GENLIB_yyval.pinval->next = 0;
		} break;
case 28:
# line 218 "readlib.y"
{ GENLIB_yyval.constrval = 0; } break;
case 29:
# line 220 "readlib.y"
{
		  GENLIB_yypvt[-0].constrval->next = GENLIB_yypvt[-1].constrval;
		  GENLIB_yyval.constrval = GENLIB_yypvt[-0].constrval;
		} break;
case 30:
# line 227 "readlib.y"
{
		  GENLIB_yyval.constrval = ALLOC(constraint_info_t, 1);
		  GENLIB_yyval.constrval->name = GENLIB_yypvt[-2].strval;
		  GENLIB_yyval.constrval->setup = GENLIB_yypvt[-1].realval;
		  GENLIB_yyval.constrval->hold = GENLIB_yypvt[-0].realval;
		  GENLIB_yyval.constrval->next = 0;
		} break;
case 31:
# line 237 "readlib.y"
{ 
		  GENLIB_yyval.latchval = ALLOC(latch_info_t, 1);
		  GENLIB_yyval.latchval->in = GENLIB_yypvt[-2].strval;
		  GENLIB_yyval.latchval->out = GENLIB_yypvt[-1].strval;
		  GENLIB_yyval.latchval->type = GENLIB_yypvt[-0].strval;
		} break;
case 32:
# line 246 "readlib.y"
{ 
		  if (strcmp(GENLIB_yytext, "RISING_EDGE") == 0) {
		    GENLIB_yyval.strval = util_strsav("re");
		  } else if (strcmp(GENLIB_yytext, "FALLING_EDGE") == 0) {
		    GENLIB_yyval.strval = util_strsav("fe");
		  } else if (strcmp(GENLIB_yytext, "ACTIVE_HIGH") == 0) {
		    GENLIB_yyval.strval = util_strsav("ah");
		  } else if (strcmp(GENLIB_yytext, "ACTIVE_LOW") == 0) {
		    GENLIB_yyval.strval = util_strsav("al");
		  } else if (strcmp(GENLIB_yytext, "ASYNCH") == 0) {
		    GENLIB_yyval.strval = util_strsav("as");
		  } else {
		    GENLIB_yyerror("latch type can only be re/fe/ah/al/as");
		  }
		} break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto GENLIB_yystack;		/* reset registers in driver code */
}

